=== modified file 'DBUS-API'
--- DBUS-API	2014-08-10 14:13:02 +0000
+++ DBUS-API	2012-01-15 20:27:28 +0000
@@ -150,6 +150,9 @@
     milliseconds, depending on ApprovedByDefault.  Approve() can now
     usefully be called on this client object.
     
+*** PropertyChanged(s: Property, v: Value)
+    The Property on this client has changed to Value.
+    
 *** Rejected(s: Reason)
     This client was not given its secret for a specified Reason.
 

=== modified file 'INSTALL'
--- INSTALL	2014-07-25 22:44:20 +0000
+++ INSTALL	2013-06-23 15:13:06 +0000
@@ -4,15 +4,14 @@
   
 ** Operating System
    
-   Debian 6.0 "squeeze" or Ubuntu 10.10 "Maverick Meerkat" (or later).
+   Debian 6.0 "squeeze" or Ubuntu 10.10 "Maverick Meerkat".
    
    This is mostly for the support scripts which make sure that the
    client is installed and started in the initial RAM disk environment
-   and that the initial RAM file system image file is automatically
-   made unreadable.  The server and client programs themselves *could*
-   be run in other distributions, but they *are* specific to GNU/Linux
-   systems, and are not written with portabillity to other Unixes in
-   mind.
+   and that the initrd.img file is automatically made unreadable.  The
+   server and client programs themselves *could* be run in other
+   distributions, but they *are* specific to GNU/Linux systems, and
+   are not written with portabillity to other Unixes in mind.
    
 ** Libraries
    
@@ -28,7 +27,7 @@
     + DocBook 4.5         http://www.docbook.org/
       Note: DocBook 5.0 is not compatible.
     + DocBook XSL stylesheets 1.71.0
-                         http://wiki.docbook.org/DocBookXslStylesheets
+                   http://wiki.docbook.org/topic/DocBookXslStylesheets
     
     Package names:
     docbook docbook-xsl
@@ -38,40 +37,32 @@
     "man -l mandos.8".
     
 *** Mandos Server
-    + GnuTLS 2.4          http://www.gnutls.org/
-      Note: GnuTLS 3 will only work with Python-GnuTLS 2
+    + GnuTLS 2.4          http://www.gnu.org/software/gnutls/
     + Avahi 0.6.16        http://www.avahi.org/
-    + Python 2.7          https://www.python.org/
-    + Python-GnuTLS 1.1.5 https://pypi.python.org/pypi/python-gnutls/
+    + Python 2.6          http://www.python.org/
+    + Python-GnuTLS 1.1.5 http://pypi.python.org/pypi/python-gnutls/
     + dbus-python 0.82.4  http://dbus.freedesktop.org/doc/dbus-python/
-    + PyGObject 2.14.2    https://developer.gnome.org/pygobject/
-    + pkg-config  http://www.freedesktop.org/wiki/Software/pkg-config/
-    + Urwid 1.0.1         http://urwid.org/
-      (Only needed by the "mandos-monitor" tool.)
+    + PyGObject 2.14.2    http://library.gnome.org/devel/pygobject/
+    + Urwid 0.9.8.3       http://excess.org/urwid/
     
     Strongly recommended:
-    + fping 2.4b2-to-ipv6      http://www.fping.org/
-    + ssh-keyscan from OpenSSH http://www.openssh.com/
+    + fping 2.4b2-to-ipv6 http://www.fping.com/
     
     Package names:
     python-gnutls avahi-daemon python python-avahi python-dbus
-    python-gobject python-urwid pkg-config fping ssh-client
+    python-gobject python-urwid
     
 *** Mandos Client
     + initramfs-tools 0.85i
-                        https://tracker.debian.org/pkg/initramfs-tools
-    + GnuTLS 2.4        http://www.gnutls.org/
-    + Avahi 0.6.16      http://www.avahi.org/
-    + GnuPG 1.4.9       https://www.gnupg.org/
-    + GPGME 1.1.6       https://www.gnupg.org/related_software/gpgme/
-    + pkg-config  http://www.freedesktop.org/wiki/Software/pkg-config/
-    
-    Strongly recommended:
-    + OpenSSH           http://www.openssh.com/
+                  http://packages.qa.debian.org/i/initramfs-tools.html
+    + GnuTLS 2.4          http://www.gnu.org/software/gnutls/
+    + Avahi 0.6.16        http://www.avahi.org/
+    + GnuPG 1.4.9         http://www.gnupg.org/
+    + GPGME 1.1.6         http://www.gnupg.org/related_software/gpgme/
     
     Package names:
     initramfs-tools libgnutls-dev libavahi-core-dev gnupg
-    libgpgme11-dev pkg-config ssh
+    libgpgme11-dev
 
 * Installing the Mandos server
   
@@ -107,11 +98,15 @@
      and append this to the file "/etc/mandos/clients.conf" *on the
      server computer*.
   
-  4. Configure the client to use any special configuration needed for
-     your local system.  Note: This is not necessary if the server is
-     present on the same wired local network as the client.  If you do
-     make changes to /etc/mandos/plugin-runner.conf, the initrd.img
-     file must be updated, possibly using the following command:
+  4. Configure the client to use the correct network interface.  The
+     interface to use is automatically chosen at boot, and if this
+     needs to be adjusted, it will be necessary to edit
+     /etc/initramfs-tools/initramfs.conf to change the DEVICE setting
+     there.  Alternatively, the file /etc/mandos/plugin-runner.conf
+     can be edited to add a "--device" parameter for the
+     mandos-client(8) plugin.  Please note: If any of those files are
+     changed, the initrd.img file must be updated, possibly using the
+     following command:
      
 	# update-initramfs -k all -u
   
@@ -131,14 +126,12 @@
      
      After this, the client computer should be able to reboot without
      needing a password entered on the console, as long as it does not
-     take more than five minutes to reboot.
+     take more than an hour to reboot.
 
 * Further customizations
   
   You may want to tighten or loosen the timeouts in the server
   configuration files; see mandos.conf(5) and mandos-clients.conf(5).
-  If IPsec is not used and SSH is not installed, it is suggested that
-  a more cryptographically secure checker program is used and
-  configured, since, without IPsec, ping packets can be faked.
-
-#+STARTUP: showall
+  If IPsec is not used, it is suggested that a more cryptographically
+  secure checker program is used and configured, since without IPsec
+  ping packets can be faked.

=== modified file 'Makefile'
--- Makefile	2015-06-28 16:35:27 +0000
+++ Makefile	2014-03-28 21:31:12 +0000
@@ -26,7 +26,7 @@
 OPTIMIZE=-Os -fno-strict-aliasing
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.6.9
+version=1.6.4
 SED=sed
 
 USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))
@@ -106,8 +106,7 @@
 PLUGINS=plugins.d/password-prompt plugins.d/mandos-client \
 	plugins.d/usplash plugins.d/splashy plugins.d/askpass-fifo \
 	plugins.d/plymouth
-PLUGIN_HELPERS=
-CPROGS=plugin-runner $(PLUGINS) $(PLUGIN_HELPERS)
+CPROGS=plugin-runner $(PLUGINS)
 PROGS=mandos mandos-keygen mandos-ctl mandos-monitor $(CPROGS)
 DOCS=mandos.8 mandos-keygen.8 mandos-monitor.8 mandos-ctl.8 \
 	mandos.conf.5 mandos-clients.conf.5 plugin-runner.8mandos \
@@ -265,19 +264,15 @@
 	@echo "# ignored.  The messages are caused by not running as root, but   #"
 	@echo "# you should NOT run \"make run-client\" as root unless you also    #"
 	@echo "# unpacked and compiled Mandos as root, which is NOT recommended. #"
-	@echo "# From plugin-runner: setgid: Operation not permitted             #"
-	@echo "#                     setuid: Operation not permitted             #"
+	@echo "# From plugin-runner: setuid: Operation not permitted             #"
 	@echo "# From askpass-fifo:  mkfifo: Permission denied                   #"
-	@echo "# From mandos-client:                                             #"
-	@echo "#             Failed to raise privileges: Operation not permitted #"
-	@echo "#             Warning: network hook \"*\" exited with status *      #"
+	@echo "# From mandos-client: setuid: Operation not permitted             #"
+	@echo "#                     seteuid: Operation not permitted            #"
+	@echo "#                     klogctl: Operation not permitted            #"
 	@echo "###################################################################"
-# We set GNOME_KEYRING_CONTROL to block pam_gnome_keyring
 	./plugin-runner --plugin-dir=plugins.d \
-		--plugin-helper-dir=plugin-helpers \
 		--config-file=plugin-runner.conf \
 		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt,--network-hook-dir=network-hooks.d \
-		--env-for=mandos-client:GNOME_KEYRING_CONTROL= \
 		$(CLIENTARGS)
 
 # Used by run-client
@@ -298,7 +293,7 @@
 	install --directory confdir
 	install --mode=u=rw $< $@
 # Add a client password
-	./mandos-keygen --dir keydir --password --no-ssh >> $@
+	./mandos-keygen --dir keydir --password >> $@
 statedir:
 	install --directory statedir
 
@@ -358,7 +353,6 @@
 	if [ "$(CONFDIR)" != "$(LIBDIR)/mandos" ]; then \
 		install --mode=u=rwx \
 			--directory "$(CONFDIR)/plugins.d"; \
-		install --directory "$(CONFDIR)/plugin-helpers"; \
 	fi
 	install --mode=u=rwx,go=rx --directory \
 		"$(CONFDIR)/network-hooks.d"

=== modified file 'NEWS'
--- NEWS	2014-10-05 20:08:58 +0000
+++ NEWS	2014-02-16 13:12:20 +0000
@@ -1,44 +1,6 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
-Version 1.6.9 (2014-10-05)
-* Server
-** Changed to emit standard D-Bus signal when D-Bus properties change.
-   (The old signal is still emitted too, but marked as deprecated.)
-
-Version 1.6.8 (2014-08-06)
-* Client
-** Bug fix: mandos-keygen now generates working SSH checker commands.
-* Server
-** Bug fix: "mandos-monitor" now really redraws screen on Ctrl-L.
-** Now requires Python 2.7.
-
-Version 1.6.7 (2014-07-17)
-* Client
-** Bug fix: Now compatible with GPGME 1.5.0.
-** Bug fix: Fixed minor memory leaks.
-* Server
-** "mandos-monitor" now has verbose logging, toggleable with "v".
-
-Version 1.6.6 (2014-07-13)
-* Client
-** If client host has an SSH server, "mandos-keygen --password" now
-   outputs "checker" option which uses "ssh-keyscan"; this is more
-   secure than the default "fping" checker.
-** Bug fix: allow "." in network hook names, to match documentation.
-** Better error messages.
-* Server
-** New --no-zeroconf option.
-** Bug fix: Fix --servicename option, broken since 1.6.4.
-** Bug fix: Fix --socket option work for --socket=0.
-
-Version 1.6.5 (2014-05-11)
-* Client
-** Work around bug in GnuPG <http://bugs.g10code.com/gnupg/issue1622>
-** Give better error messages when run without sufficient privileges
-** Only warn if workaround for Debian bug #633582 was necessary and
-   failed, not if it failed and was unnecessary.
-
 Version 1.6.4 (2014-02-16)
 * Server
 ** Very minor fix to self-test code.

=== modified file 'TODO'
--- TODO	2014-10-05 19:39:25 +0000
+++ TODO	2014-03-27 21:24:33 +0000
@@ -23,7 +23,6 @@
 ** TODO [#B] Use capabilities instead of seteuid().
 ** TODO [#B] Use getaddrinfo(hints=AI_NUMERICHOST) instead of inet_pton()
 ** TODO [#C] Make start_mandos_communication() take "struct server".
-** TODO [#C] --interfaces=regex,eth*,noregex (bridge-utils-interfaces(5))
 
 * splashy
 ** TODO [#B] use scandir(3) instead of readdir(3)
@@ -33,6 +32,7 @@
 ** TODO [#B] use scandir(3) instead of readdir(3)
 
 * askpass-fifo
+** TODO [#B] Drop privileges after opening FIFO.
 
 * password-prompt
 ** TODO [#B] lock stdin (with flock()?)
@@ -44,13 +44,12 @@
 * plugin-runner
 ** TODO handle printing for errors for plugins
 *** Hook up stderr of plugins, buffer them, and prepend "Mandos Plugin [plugin name]"
+** TODO [#B] use scandirat(3) instead of readdir(3)
+*** Must wait until GNU libc 2.15
 ** TODO [#C] use same file name rules as run-parts(8)
 ** kernel command line option for debug info
 
 * mandos (server)
-** TODO [#B] Work around Avahi issue
-   Avahi does not announce link-local addresses if any global
-   addresses exist: http://lists.freedesktop.org/archives/avahi/2010-March/001863.html
 ** TODO [#B] Log level							  :BUGS:
 *** TODO /etc/mandos/clients.d/*.conf
     Watch this directory and add/remove/update clients?
@@ -72,6 +71,9 @@
 ** TODO Use python-tlslite?
 ** TODO D-Bus AddClient() method on server object
 ** TODO Use org.freedesktop.DBus.Method.NoReply annotation on async methods. :2:
+** TODO Emit [[http://dbus.freedesktop.org/doc/dbus-specification.html#standard-interfaces-properties][org.freedesktop.DBus.Properties.PropertiesChanged]] signal	  :2:
+   TODO Deprecate se.recompile.Mandos.Client.PropertyChanged - annotate!
+   TODO Can use "invalidates" annotation to also emit on changed secret.
 ** TODO Support [[http://dbus.freedesktop.org/doc/dbus-specification.html#standard-interfaces-objectmanager][org.freedesktop.DBus.ObjectManager]] interface on server object :2:
    Deprecate methods GetAllClients(), GetAllClientsWithProperties()
    and signals ClientAdded and ClientRemoved.
@@ -80,13 +82,8 @@
 ** TODO Secret Service API?
    http://standards.freedesktop.org/secret-service/
 ** TODO Remove D-Bus interfaces with old domain name			  :2:
-** TODO Remove old string_to_delta format				     :2:
-** TODO http://0pointer.de/blog/projects/stateless.html
-*** tmpfiles snippet to create /var/lib/mandos with right user+perms
-*** File in /usr/lib/sysusers.d to create user+group "_mandos"
-** TODO Error handling on error parsing config files
-** TODO init.d script error handling
-** TODO D-Bus server properties; address, port, interface, etc.		     :2:
+** TODO Remove old string_to_delta format				  :2:
+** TODO --no-zeroconf (only valid if port or socket is set)
 
 * mandos.xml
 ** Add mandos contact info in manual pages
@@ -94,7 +91,7 @@
 * mandos-ctl
 *** Handle "no D-Bus server" and/or "no Mandos server found" better
 *** [#B] --dump option
-** TODO Remove old string_to_delta format				     :2:
+** TODO Remove old string_to_delta format				  :2:
 
 * TODO mandos-dispatch
   Listens for specified D-Bus signals and spawns shell commands with

=== modified file 'common.ent'
--- common.ent	2014-10-05 20:08:58 +0000
+++ common.ent	2014-02-16 13:12:20 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.6.9">
+<!ENTITY version "1.6.4">

=== modified file 'debian/changelog'
--- debian/changelog	2014-10-05 20:08:58 +0000
+++ debian/changelog	2014-02-16 13:12:20 +0000
@@ -1,69 +1,3 @@
-mandos (1.6.9-1) unstable; urgency=medium
-
-  * New upstream release.
-  * debian/control (Build-Depends): Fix "still uses GnutLS 2.x" by
-    changing from "libgnutls-dev" to "libgnutls28-dev | gnutls-dev"
-    (Closes: #762349)
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 05 Oct 2014 22:05:06 +0200
-
-mandos (1.6.8-1) unstable; urgency=medium
-
-  * New upstream release.
-  * debian/control (Source: mandos/Build-Depends-Indep): Since upstream
-    now requires Python 2.7, depend on exactly the python2.7 package and
-    all the Python 2.7 versions of the python modules.
-    (Package: mandos/Depends): - '' - but still depend on python (>=2.7)
-    and the generic versions of the Python modules; this is for mandos-ctl
-    and mandos-monitor, both of which are compatible with Python 3, and
-    use #!/usr/bin/python.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Wed, 06 Aug 2014 22:55:24 +0200
-
-mandos (1.6.7-1) unstable; urgency=medium
-
-  * New upstream release.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Thu, 17 Jul 2014 05:22:45 +0200
-
-mandos (1.6.6-1) unstable; urgency=medium
-
-  * New upstream release.
-  * debian/mandos.postinst: Fix typo in comment.
-  * debian/control (mandos/Recommends): Changed to "ssh-client | fping".
-    (mandos-client/Recommends): New; set to "ssh".
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 13 Jul 2014 22:49:21 +0200
-
-mandos (1.6.5-3) unstable; urgency=medium
-
-  * debian/control (mandos-client/Depends): Add "dpkg-dev (>=1.16.0)";
-    initramfs-tools-hook runs "dpkg-architecture -qDEB_HOST_MULTIARCH".
-    (Closes: #750221)
-
- -- Teddy Hogeborn <teddy@recompile.se>  Fri, 06 Jun 2014 04:27:15 +0200
-
-mandos (1.6.5-2) unstable; urgency=medium
-
-  * debian/rules (override_dh_auto_test-arch): New; does nothing.  Fixes
-    FTBFS for build-indep.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Tue, 13 May 2014 08:08:31 +0200
-
-mandos (1.6.5-1) unstable; urgency=medium
-
-  * New upstream release.
-  * debian/copyright: Change year to "2014".
-  * debian/control (Build-Depends, Build-Depends-Indep): Moved build
-    dependencies of "mandos" package to "Build-Depends-Indep".
-  * debian/upstream/signing-key.asc: New; upstream source public key.
-  * debian/control (Standards-Version): Updated to "3.9.5".
-  * debian/control (mandos/Depends): Remove the dependency on
-    "avahi-daemon (>= 0.6.31-3) | systemd-sysv".  It is unnecessary
-    since we have a workaround in debian/mandos.postinst anyway.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 11 May 2014 22:16:33 +0200
-
 mandos (1.6.4-1) unstable; urgency=medium
 
   * New upstream release.

=== modified file 'debian/control'
--- debian/control	2014-10-08 21:03:05 +0000
+++ debian/control	2014-03-01 10:59:22 +0000
@@ -5,23 +5,24 @@
 Uploaders: Teddy Hogeborn <teddy@recompile.se>,
 	   Björn Påhlsson <belorn@recompile.se>
 Build-Depends: debhelper (>= 9), docbook-xml, docbook-xsl,
-	libavahi-core-dev, libgpgme11-dev, libgnutls28-dev
-	| gnutls-dev, xsltproc, pkg-config
-Build-Depends-Indep: systemd, python2.7, python2.7-gnutls,
-	python2.7-dbus, python2.7-avahi, python2.7-gobject
-Standards-Version: 3.9.6
+	libavahi-core-dev, libgpgme11-dev, libgnutls-dev, xsltproc,
+	pkg-config
+Build-Depends-Indep: systemd, python (>=2.6), python-gnutls,
+	python-dbus, python-avahi, python-gobject,
+	python (>=2.7) | python-argparse
+Standards-Version: 3.9.5
 Vcs-Bzr: http://ftp.recompile.se/pub/mandos/trunk
 Vcs-Browser: http://bzr.recompile.se/loggerhead/mandos/trunk/files
 Homepage: http://www.recompile.se/mandos
 
 Package: mandos
 Architecture: all
-Depends: ${misc:Depends}, python (>= 2.7), python2.7, python-gnutls,
-	python2.7-gnutls, python-dbus, python2.7-dbus, python-avahi,
-	python2.7-avahi, python-gobject, python2.7-gobject,
-	avahi-daemon, adduser, python-urwid, python2.7-urwid,
-	gnupg (<< 2), initscripts (>= 2.88dsf-13.3)
-Recommends: ssh-client | fping
+Depends: ${misc:Depends}, python (>=2.6), python-gnutls, python-dbus,
+	python-avahi, python-gobject, avahi-daemon, adduser,
+	python-urwid, python (>=2.7) | python-argparse, gnupg (<< 2),
+	initscripts (>= 2.88dsf-13.3), avahi-daemon (>= 0.6.31-3)
+	| systemd-sysv
+Recommends: fping
 Description: server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows
  computers to have encrypted root file systems and at the
@@ -40,8 +41,7 @@
 Package: mandos-client
 Architecture: linux-any
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup,
-	gnupg (<< 2), initramfs-tools, dpkg-dev (>=1.16.0)
-Recommends: ssh
+	gnupg (<< 2), initramfs-tools
 Breaks: dropbear (<= 0.53.1-1)
 Enhances: cryptsetup
 Description: do unattended reboots with an encrypted root file system

=== modified file 'debian/mandos.postinst'
--- debian/mandos.postinst	2014-06-07 20:29:36 +0000
+++ debian/mandos.postinst	2014-01-06 17:22:30 +0000
@@ -51,7 +51,7 @@
 # "avahi-daemon") in its /etc/init.d script header.  To make
 # insserv(8) happy, we edit our /etc/init.d script header to contain
 # the correct string before the code added by dh_installinit calls
-# update.rc-d, which calls insserv.
+# update.rd-c, which calls insserv.
 avahi_version="`dpkg-query --showformat='${Version}' --show avahi-daemon`"
 if dpkg --compare-versions "$avahi_version" le 0.6.31-2; then
     sed --in-place --expression='/^### BEGIN INIT INFO$/,/^### END INIT INFO$/s/^\(# Required-\(Stop\|Start\):.*avahi\)-daemon\>/\1/g' /etc/init.d/mandos

=== modified file 'debian/rules'
--- debian/rules	2014-05-12 21:02:38 +0000
+++ debian/rules	2014-01-20 21:50:11 +0000
@@ -27,5 +27,3 @@
 		--exclude usr/share/doc/mandos-client/examples/network-hooks.d
 	chmod --recursive g-w -- \
 	"$(CURDIR)/debian/mandos-client/usr/share/doc/mandos-client/examples/network-hooks.d"
-
-override_dh_auto_test-arch: ;

=== modified file 'initramfs-tools-hook'
--- initramfs-tools-hook	2015-06-28 16:35:27 +0000
+++ initramfs-tools-hook	2013-10-28 08:38:47 +0000
@@ -70,13 +70,11 @@
 CONFDIR="/conf/conf.d/mandos"
 MANDOSDIR="/lib/mandos"
 PLUGINDIR="${MANDOSDIR}/plugins.d"
-PLUGINHELPERDIR="${MANDOSDIR}/plugins-helpers"
 HOOKDIR="${MANDOSDIR}/network-hooks.d"
 
 # Make directories
 install --directory --mode=u=rwx,go=rx "${DESTDIR}${CONFDIR}" \
-	"${DESTDIR}${MANDOSDIR}" "${DESTDIR}${HOOKDIR}" \
-	"${DESTDIR}${PLUGINHELPERDIR}"
+	"${DESTDIR}${MANDOSDIR}" "${DESTDIR}${HOOKDIR}"
 install --owner=${mandos_user} --group=${mandos_group} --directory \
     --mode=u=rwx "${DESTDIR}${PLUGINDIR}"
 
@@ -100,21 +98,6 @@
     esac
 done
 
-# Copy the packaged plugin helpers
-for file in "$libdir"/mandos/plugin-helpers/*; do
-    base="`basename \"$file\"`"
-    # Is this plugin overridden?
-    if [ -e "/etc/mandos/plugin-helpers/$base" ]; then
-	continue
-    fi
-    case "$base" in
-	*~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert)
-	    : ;;
-	"*") : ;;
-	*) copy_exec "$file" "${PLUGINHELPERDIR}" ;;
-    esac
-done
-
 # Copy any user-supplied plugins
 for file in /etc/mandos/plugins.d/*; do
     base="`basename \"$file\"`"
@@ -126,17 +109,6 @@
     esac
 done
 
-# Copy any user-supplied plugin helpers
-for file in /etc/mandos/plugin-helpers/*; do
-    base="`basename \"$file\"`"
-    case "$base" in
-	*~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert)
-	    : ;;
-	"*") : ;;
-	*) copy_exec "$file" "${PLUGINHELPERDIR}" ;;
-    esac
-done
-
 # Get DEVICE from initramfs.conf and other files
 . /etc/initramfs-tools/initramfs.conf
 for conf in /etc/initramfs-tools/conf.d/*; do
@@ -178,17 +150,11 @@
 done
 
 # GPGME needs GnuPG
-gpg=/usr/bin/gpg
 libgpgme11_version="`dpkg-query --showformat='${Version}' --show libgpgme11`"
-if dpkg --compare-versions "$libgpgme11_version" ge 1.5.0-0.1; then
-    if [ -e /usr/bin/gpgconf ]; then
-	if [ ! -e "${DESTDIR}/usr/bin/gpgconf" ]; then
-	    copy_exec /usr/bin/gpgconf
-	fi
-	gpg="`/usr/bin/gpgconf|sed --quiet --expression='s/^gpg:[^:]*://p'`"
-    fi
-elif dpkg --compare-versions "$libgpgme11_version" ge 1.4.1-0.1; then
+if dpkg --compare-versions "$libgpgme11_version" ge 1.4.1-0.1; then
     gpg=/usr/bin/gpg2
+else
+    gpg=/usr/bin/gpg
 fi
 if [ ! -e "${DESTDIR}$gpg" ]; then
     copy_exec "$gpg"

=== modified file 'intro.xml'
--- intro.xml	2014-06-22 02:19:30 +0000
+++ intro.xml	2011-12-31 23:05:34 +0000
@@ -1,7 +1,7 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
-<!ENTITY TIMESTAMP "2014-06-22">
+<!ENTITY TIMESTAMP "2012-01-01">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -215,22 +215,17 @@
       </para>
     </refsect2>
     
-    <refsect2 id="fakecheck">
-      <title>Faking checker results?</title>
+    <refsect2 id="fakeping">
+      <title>Faking ping replies?</title>
       <para>
-	If the Mandos client does not have an SSH server, the default
-	is for the Mandos server to use
+	The default for the server is to use
 	<quote><literal>fping</literal></quote>, the replies to which
 	could be faked to eliminate the timeout.  But this could
 	easily be changed to any shell command, with any security
-	measures you like.  If the Mandos client
-	<emphasis>has</emphasis> an SSH server, the default
-	configuration (as generated by
-	<command>mandos-keygen</command> with the
-	<option>--password</option> option) is for the Mandos server
-	to use an <command>ssh-keyscan</command> command with strict
-	keychecking, which can not be faked.  Alternatively, IPsec
-	could be used for the ping packets, making them secure.
+	measures you like.  It could, for instance, be changed to an
+	SSH command with strict keychecking, which could not be faked.
+	Or IPsec could be used for the ping packets, making them
+	secure.
       </para>
     </refsect2>
   </refsect1>

=== modified file 'mandos'
--- mandos	2014-10-08 21:07:10 +0000
+++ mandos	2014-02-22 17:13:00 +0000
@@ -1,4 +1,4 @@
-#!/usr/bin/python2.7
+#!/usr/bin/python
 # -*- mode: python; coding: utf-8 -*-
 # 
 # Mandos server - give out binary blobs to connecting clients.
@@ -88,10 +88,7 @@
     except ImportError:
         SO_BINDTODEVICE = None
 
-if sys.version_info.major == 2:
-    str = unicode
-
-version = "1.6.9"
+version = "1.6.4"
 stored_state_file = "clients.pickle"
 
 logger = logging.getLogger()
@@ -107,19 +104,20 @@
         SIOCGIFINDEX = 0x8933  # From /usr/include/linux/sockios.h
         with contextlib.closing(socket.socket()) as s:
             ifreq = fcntl.ioctl(s, SIOCGIFINDEX,
-                                struct.pack(b"16s16x", interface))
-        interface_index = struct.unpack("I", ifreq[16:20])[0]
+                                struct.pack(str("16s16x"),
+                                            interface))
+        interface_index = struct.unpack(str("I"),
+                                        ifreq[16:20])[0]
         return interface_index
 
 
 def initlogger(debug, level=logging.WARNING):
     """init logger and add loglevel"""
     
-    global syslogger
     syslogger = (logging.handlers.SysLogHandler
                  (facility =
                   logging.handlers.SysLogHandler.LOG_DAEMON,
-                  address = "/dev/log"))
+                  address = str("/dev/log")))
     syslogger.setFormatter(logging.Formatter
                            ('Mandos [%(process)d]: %(levelname)s:'
                             ' %(message)s'))
@@ -225,8 +223,9 @@
 class AvahiError(Exception):
     def __init__(self, value, *args, **kwargs):
         self.value = value
-        return super(AvahiError, self).__init__(value, *args,
-                                                **kwargs)
+        super(AvahiError, self).__init__(value, *args, **kwargs)
+    def __unicode__(self):
+        return unicode(repr(self.value))
 
 class AvahiServiceError(AvahiError):
     pass
@@ -275,31 +274,25 @@
         self.bus = bus
         self.entry_group_state_changed_match = None
     
-    def rename(self, remove=True):
+    def rename(self):
         """Derived from the Avahi example code"""
         if self.rename_count >= self.max_renames:
             logger.critical("No suitable Zeroconf service name found"
                             " after %i retries, exiting.",
                             self.rename_count)
             raise AvahiServiceError("Too many renames")
-        self.name = str(self.server
-                        .GetAlternativeServiceName(self.name))
-        self.rename_count += 1
+        self.name = unicode(self.server
+                            .GetAlternativeServiceName(self.name))
         logger.info("Changing Zeroconf service name to %r ...",
                     self.name)
-        if remove:
-            self.remove()
+        self.remove()
         try:
             self.add()
         except dbus.exceptions.DBusException as error:
-            if (error.get_dbus_name()
-                == "org.freedesktop.Avahi.CollisionError"):
-                logger.info("Local Zeroconf service name collision.")
-                return self.rename(remove=False)
-            else:
-                logger.critical("D-Bus Exception", exc_info=error)
-                self.cleanup()
-                os._exit(1)
+            logger.critical("D-Bus Exception", exc_info=error)
+            self.cleanup()
+            os._exit(1)
+        self.rename_count += 1
     
     def remove(self):
         """Derived from the Avahi example code"""
@@ -343,8 +336,8 @@
             self.rename()
         elif state == avahi.ENTRY_GROUP_FAILURE:
             logger.critical("Avahi: Error in group state changed %s",
-                            str(error))
-            raise AvahiGroupError("State changed: {!s}"
+                            unicode(error))
+            raise AvahiGroupError("State changed: {0!s}"
                                   .format(error))
     
     def cleanup(self):
@@ -397,16 +390,23 @@
 
 
 class AvahiServiceToSyslog(AvahiService):
-    def rename(self, *args, **kwargs):
+    def rename(self):
         """Add the new name to the syslog messages"""
-        ret = AvahiService.rename(self, *args, **kwargs)
+        ret = AvahiService.rename(self)
         syslogger.setFormatter(logging.Formatter
-                               ('Mandos ({}) [%(process)d]:'
+                               ('Mandos ({0}) [%(process)d]:'
                                 ' %(levelname)s: %(message)s'
                                 .format(self.name)))
         return ret
 
 
+def timedelta_to_milliseconds(td):
+    "Convert a datetime.timedelta() to milliseconds"
+    return ((td.days * 24 * 60 * 60 * 1000)
+            + (td.seconds * 1000)
+            + (td.microseconds // 1000))
+
+
 class Client(object):
     """A representation of a client host served by this server.
     
@@ -467,6 +467,21 @@
                         "enabled": "True",
                         }
     
+    def timeout_milliseconds(self):
+        "Return the 'timeout' attribute in milliseconds"
+        return timedelta_to_milliseconds(self.timeout)
+    
+    def extended_timeout_milliseconds(self):
+        "Return the 'extended_timeout' attribute in milliseconds"
+        return timedelta_to_milliseconds(self.extended_timeout)
+    
+    def interval_milliseconds(self):
+        "Return the 'interval' attribute in milliseconds"
+        return timedelta_to_milliseconds(self.interval)
+    
+    def approval_delay_milliseconds(self):
+        return timedelta_to_milliseconds(self.approval_delay)
+    
     @staticmethod
     def config_parser(config):
         """Construct a new dict of client settings of this form:
@@ -497,7 +512,7 @@
                           "rb") as secfile:
                     client["secret"] = secfile.read()
             else:
-                raise TypeError("No secret or secfile for section {}"
+                raise TypeError("No secret or secfile for section {0}"
                                 .format(section))
             client["timeout"] = string_to_delta(section["timeout"])
             client["extended_timeout"] = string_to_delta(
@@ -520,7 +535,7 @@
             server_settings = {}
         self.server_settings = server_settings
         # adding all client settings
-        for setting, value in settings.items():
+        for setting, value in settings.iteritems():
             setattr(self, setting, value)
         
         if self.enabled:
@@ -609,16 +624,14 @@
         if self.checker_initiator_tag is not None:
             gobject.source_remove(self.checker_initiator_tag)
         self.checker_initiator_tag = (gobject.timeout_add
-                                      (int(self.interval
-                                           .total_seconds() * 1000),
+                                      (self.interval_milliseconds(),
                                        self.start_checker))
         # Schedule a disable() when 'timeout' has passed
         if self.disable_initiator_tag is not None:
             gobject.source_remove(self.disable_initiator_tag)
         self.disable_initiator_tag = (gobject.timeout_add
-                                      (int(self.timeout
-                                           .total_seconds() * 1000),
-                                       self.disable))
+                                   (self.timeout_milliseconds(),
+                                    self.disable))
         # Also start a new checker *right now*.
         self.start_checker()
     
@@ -655,8 +668,8 @@
             self.disable_initiator_tag = None
         if getattr(self, "enabled", False):
             self.disable_initiator_tag = (gobject.timeout_add
-                                          (int(timeout.total_seconds()
-                                               * 1000), self.disable))
+                                          (timedelta_to_milliseconds
+                                           (timeout), self.disable))
             self.expires = datetime.datetime.utcnow() + timeout
     
     def need_approval(self):
@@ -693,9 +706,10 @@
         # Start a new checker if needed
         if self.checker is None:
             # Escape attributes for the shell
-            escaped_attrs = { attr:
-                                  re.escape(str(getattr(self, attr)))
-                              for attr in self.runtime_expansions }
+            escaped_attrs = dict(
+                (attr, re.escape(unicode(getattr(self, attr))))
+                for attr in
+                self.runtime_expansions)
             try:
                 command = self.checker_command % escaped_attrs
             except TypeError as error:
@@ -782,7 +796,7 @@
     # "Set" method, so we fail early here:
     if byte_arrays and signature != "ay":
         raise ValueError("Byte arrays not supported for non-'ay'"
-                         " signature {!r}".format(signature))
+                         " signature {0!r}".format(signature))
     def decorator(func):
         func._dbus_is_property = True
         func._dbus_interface = dbus_interface
@@ -819,11 +833,11 @@
     """Decorator to annotate D-Bus methods, signals or properties
     Usage:
     
-    @dbus_annotations({"org.freedesktop.DBus.Deprecated": "true",
-                       "org.freedesktop.DBus.Property."
-                       "EmitsChangedSignal": "false"})
     @dbus_service_property("org.example.Interface", signature="b",
                            access="r")
+    @dbus_annotations({{"org.freedesktop.DBus.Deprecated": "true",
+                        "org.freedesktop.DBus.Property."
+                        "EmitsChangedSignal": "false"})
     def Property_dbus_property(self):
         return dbus.Boolean(False)
     """
@@ -836,7 +850,9 @@
 class DBusPropertyException(dbus.exceptions.DBusException):
     """A base class for D-Bus property-related exceptions
     """
-    pass
+    def __unicode__(self):
+        return unicode(str(self))
+
 
 class DBusPropertyAccessException(DBusPropertyException):
     """A property's access permissions disallows an operation.
@@ -865,7 +881,7 @@
         If called like _is_dbus_thing("method") it returns a function
         suitable for use as predicate to inspect.getmembers().
         """
-        return lambda obj: getattr(obj, "_dbus_is_{}".format(thing),
+        return lambda obj: getattr(obj, "_dbus_is_{0}".format(thing),
                                    False)
     
     def _get_all_dbus_things(self, thing):
@@ -921,7 +937,7 @@
             # signatures other than "ay".
             if prop._dbus_signature != "ay":
                 raise ValueError("Byte arrays not supported for non-"
-                                 "'ay' signature {!r}"
+                                 "'ay' signature {0!r}"
                                  .format(prop._dbus_signature))
             value = dbus.ByteArray(b''.join(chr(byte)
                                             for byte in value))
@@ -952,14 +968,6 @@
                                            value.variant_level+1)
         return dbus.Dictionary(properties, signature="sv")
     
-    @dbus.service.signal(dbus.PROPERTIES_IFACE, signature="sa{sv}as")
-    def PropertiesChanged(self, interface_name, changed_properties,
-                          invalidated_properties):
-        """Standard D-Bus PropertiesChanged() signal, see D-Bus
-        standard.
-        """
-        pass
-    
     @dbus.service.method(dbus.INTROSPECTABLE_IFACE,
                          out_signature="s",
                          path_keyword='object_path',
@@ -1000,7 +1008,7 @@
                                               (prop,
                                                "_dbus_annotations",
                                                {}))
-                        for name, value in annots.items():
+                        for name, value in annots.iteritems():
                             ann_tag = document.createElement(
                                 "annotation")
                             ann_tag.setAttribute("name", name)
@@ -1009,11 +1017,11 @@
                 # Add interface annotation tags
                 for annotation, value in dict(
                     itertools.chain.from_iterable(
-                        annotations().items()
+                        annotations().iteritems()
                         for name, annotations in
                         self._get_all_dbus_things("interface")
                         if name == if_tag.getAttribute("name")
-                        )).items():
+                        )).iteritems():
                     ann_tag = document.createElement("annotation")
                     ann_tag.setAttribute("name", annotation)
                     ann_tag.setAttribute("value", value)
@@ -1075,7 +1083,7 @@
     """
     def wrapper(cls):
         for orig_interface_name, alt_interface_name in (
-            alt_interface_names.items()):
+            alt_interface_names.iteritems()):
             attr = {}
             interface_names = set()
             # Go though all attributes of the class
@@ -1198,7 +1206,7 @@
                                         attribute.func_closure)))
             if deprecate:
                 # Deprecate all alternate interfaces
-                iname="_AlternateDBusNames_interface_annotation{}"
+                iname="_AlternateDBusNames_interface_annotation{0}"
                 for interface_name in interface_names:
                     @dbus_interface_annotations(interface_name)
                     def func(self):
@@ -1213,7 +1221,7 @@
             if interface_names:
                 # Replace the class with a new subclass of it with
                 # methods, signals, etc. as created above.
-                cls = type(b"{}Alternate".format(cls.__name__),
+                cls = type(b"{0}Alternate".format(cls.__name__),
                            (cls,), attr)
         return cls
     return wrapper
@@ -1232,8 +1240,6 @@
     runtime_expansions = (Client.runtime_expansions
                           + ("dbus_object_path",))
     
-    _interface = "se.recompile.Mandos.Client"
-    
     # dbus.service.Object doesn't use super(), so we can't either.
     
     def __init__(self, bus = None, *args, **kwargs):
@@ -1241,7 +1247,7 @@
         Client.__init__(self, *args, **kwargs)
         # Only now, when this client is initialized, can it show up on
         # the D-Bus
-        client_object_name = str(self.name).translate(
+        client_object_name = unicode(self.name).translate(
             {ord("."): ord("_"),
              ord("-"): ord("_")})
         self.dbus_object_path = (dbus.ObjectPath
@@ -1251,8 +1257,7 @@
     
     def notifychangeproperty(transform_func,
                              dbus_name, type_func=lambda x: x,
-                             variant_level=1, invalidate_only=False,
-                             _interface=_interface):
+                             variant_level=1):
         """ Modify a variable so that it's a property which announces
         its changes to DBus.
         
@@ -1263,27 +1268,17 @@
                    to the D-Bus.  Default: no transform
         variant_level: D-Bus variant level.  Default: 1
         """
-        attrname = "_{}".format(dbus_name)
+        attrname = "_{0}".format(dbus_name)
         def setter(self, value):
             if hasattr(self, "dbus_object_path"):
                 if (not hasattr(self, attrname) or
                     type_func(getattr(self, attrname, None))
                     != type_func(value)):
-                    if invalidate_only:
-                        self.PropertiesChanged(_interface,
-                                               dbus.Dictionary(),
-                                               dbus.Array
-                                               ((dbus_name,)))
-                    else:
-                        dbus_value = transform_func(type_func(value),
-                                                    variant_level
-                                                    =variant_level)
-                        self.PropertyChanged(dbus.String(dbus_name),
-                                             dbus_value)
-                        self.PropertiesChanged(_interface,
-                                               dbus.Dictionary({
-                                    dbus.String(dbus_name):
-                                        dbus_value }), dbus.Array())
+                    dbus_value = transform_func(type_func(value),
+                                                variant_level
+                                                =variant_level)
+                    self.PropertyChanged(dbus.String(dbus_name),
+                                         dbus_value)
             setattr(self, attrname, value)
         
         return property(lambda self: getattr(self, attrname), setter)
@@ -1309,26 +1304,22 @@
     approval_delay = notifychangeproperty(dbus.UInt64,
                                           "ApprovalDelay",
                                           type_func =
-                                          lambda td: td.total_seconds()
-                                          * 1000)
+                                          timedelta_to_milliseconds)
     approval_duration = notifychangeproperty(
         dbus.UInt64, "ApprovalDuration",
-        type_func = lambda td: td.total_seconds() * 1000)
+        type_func = timedelta_to_milliseconds)
     host = notifychangeproperty(dbus.String, "Host")
     timeout = notifychangeproperty(dbus.UInt64, "Timeout",
-                                   type_func = lambda td:
-                                       td.total_seconds() * 1000)
+                                   type_func =
+                                   timedelta_to_milliseconds)
     extended_timeout = notifychangeproperty(
         dbus.UInt64, "ExtendedTimeout",
-        type_func = lambda td: td.total_seconds() * 1000)
+        type_func = timedelta_to_milliseconds)
     interval = notifychangeproperty(dbus.UInt64,
                                     "Interval",
                                     type_func =
-                                    lambda td: td.total_seconds()
-                                    * 1000)
+                                    timedelta_to_milliseconds)
     checker_command = notifychangeproperty(dbus.String, "Checker")
-    secret = notifychangeproperty(dbus.ByteArray, "Secret",
-                                  invalidate_only=True)
     
     del notifychangeproperty
     
@@ -1376,14 +1367,21 @@
     
     def approve(self, value=True):
         self.approved = value
-        gobject.timeout_add(int(self.approval_duration.total_seconds()
-                                * 1000), self._reset_approved)
+        gobject.timeout_add(timedelta_to_milliseconds
+                            (self.approval_duration),
+                            self._reset_approved)
         self.send_changedstate()
     
     ## D-Bus methods, signals & properties
+    _interface = "se.recompile.Mandos.Client"
     
     ## Interfaces
     
+    @dbus_interface_annotations(_interface)
+    def _foo(self):
+        return { "org.freedesktop.DBus.Property.EmitsChangedSignal":
+                     "false"}
+    
     ## Signals
     
     # CheckerCompleted - signal
@@ -1399,7 +1397,6 @@
         pass
     
     # PropertyChanged - signal
-    @dbus_annotations({"org.freedesktop.DBus.Deprecated": "true"})
     @dbus.service.signal(_interface, signature="sv")
     def PropertyChanged(self, property, value):
         "D-Bus signal"
@@ -1481,8 +1478,7 @@
                            access="readwrite")
     def ApprovalDelay_dbus_property(self, value=None):
         if value is None:       # get
-            return dbus.UInt64(self.approval_delay.total_seconds()
-                               * 1000)
+            return dbus.UInt64(self.approval_delay_milliseconds())
         self.approval_delay = datetime.timedelta(0, 0, 0, value)
     
     # ApprovalDuration - property
@@ -1490,8 +1486,8 @@
                            access="readwrite")
     def ApprovalDuration_dbus_property(self, value=None):
         if value is None:       # get
-            return dbus.UInt64(self.approval_duration.total_seconds()
-                               * 1000)
+            return dbus.UInt64(timedelta_to_milliseconds(
+                    self.approval_duration))
         self.approval_duration = datetime.timedelta(0, 0, 0, value)
     
     # Name - property
@@ -1510,7 +1506,7 @@
     def Host_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.String(self.host)
-        self.host = str(value)
+        self.host = unicode(value)
     
     # Created - property
     @dbus_service_property(_interface, signature="s", access="read")
@@ -1563,7 +1559,7 @@
                            access="readwrite")
     def Timeout_dbus_property(self, value=None):
         if value is None:       # get
-            return dbus.UInt64(self.timeout.total_seconds() * 1000)
+            return dbus.UInt64(self.timeout_milliseconds())
         old_timeout = self.timeout
         self.timeout = datetime.timedelta(0, 0, 0, value)
         # Reschedule disabling
@@ -1580,16 +1576,15 @@
                 gobject.source_remove(self.disable_initiator_tag)
                 self.disable_initiator_tag = (
                     gobject.timeout_add(
-                        int((self.expires - now).total_seconds()
-                            * 1000), self.disable))
+                        timedelta_to_milliseconds(self.expires - now),
+                        self.disable))
     
     # ExtendedTimeout - property
     @dbus_service_property(_interface, signature="t",
                            access="readwrite")
     def ExtendedTimeout_dbus_property(self, value=None):
         if value is None:       # get
-            return dbus.UInt64(self.extended_timeout.total_seconds()
-                               * 1000)
+            return dbus.UInt64(self.extended_timeout_milliseconds())
         self.extended_timeout = datetime.timedelta(0, 0, 0, value)
     
     # Interval - property
@@ -1597,7 +1592,7 @@
                            access="readwrite")
     def Interval_dbus_property(self, value=None):
         if value is None:       # get
-            return dbus.UInt64(self.interval.total_seconds() * 1000)
+            return dbus.UInt64(self.interval_milliseconds())
         self.interval = datetime.timedelta(0, 0, 0, value)
         if getattr(self, "checker_initiator_tag", None) is None:
             return
@@ -1614,7 +1609,7 @@
     def Checker_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.String(self.checker_command)
-        self.checker_command = str(value)
+        self.checker_command = unicode(value)
     
     # CheckerRunning - property
     @dbus_service_property(_interface, signature="b",
@@ -1636,7 +1631,7 @@
     @dbus_service_property(_interface, signature="ay",
                            access="write", byte_arrays=True)
     def Secret_dbus_property(self, value):
-        self.secret = bytes(value)
+        self.secret = str(value)
     
     del _interface
 
@@ -1676,7 +1671,7 @@
     def handle(self):
         with contextlib.closing(self.server.child_pipe) as child_pipe:
             logger.info("TCP connection from: %s",
-                        str(self.client_address))
+                        unicode(self.client_address))
             logger.debug("Pipe FD: %d",
                          self.server.child_pipe.fileno())
             
@@ -1763,8 +1758,8 @@
                         if self.server.use_dbus:
                             # Emit D-Bus signal
                             client.NeedApproval(
-                                client.approval_delay.total_seconds()
-                                * 1000, client.approved_by_default)
+                                client.approval_delay_milliseconds(),
+                                client.approved_by_default)
                     else:
                         logger.warning("Client %s was not approved",
                                        client.name)
@@ -1776,7 +1771,9 @@
                     #wait until timeout or approved
                     time = datetime.datetime.now()
                     client.changedstate.acquire()
-                    client.changedstate.wait(delay.total_seconds())
+                    client.changedstate.wait(
+                        float(timedelta_to_milliseconds(delay)
+                              / 1000))
                     client.changedstate.release()
                     time2 = datetime.datetime.now()
                     if (time2 - time) >= delay:
@@ -1981,8 +1978,7 @@
                 try:
                     self.socket.setsockopt(socket.SOL_SOCKET,
                                            SO_BINDTODEVICE,
-                                           (self.interface + "\0")
-                                           .encode("utf-8"))
+                                           str(self.interface + '\0'))
                 except socket.error as error:
                     if error.errno == errno.EPERM:
                         logger.error("No permission to bind to"
@@ -2191,11 +2187,11 @@
     token_duration = Token(re.compile(r"P"), None,
                            frozenset((token_year, token_month,
                                       token_day, token_time,
-                                      token_week)))
+                                      token_week))),
     # Define starting values
     value = datetime.timedelta() # Value so far
     found_token = None
-    followers = frozenset((token_duration,)) # Following valid tokens
+    followers = frozenset(token_duration,) # Following valid tokens
     s = duration                # String left to parse
     # Loop until end token is found
     while found_token is not token_end:
@@ -2248,7 +2244,7 @@
     timevalue = datetime.timedelta(0)
     for s in interval.split():
         try:
-            suffix = s[-1]
+            suffix = unicode(s[-1])
             value = int(s[:-1])
             if suffix == "d":
                 delta = datetime.timedelta(value)
@@ -2261,7 +2257,7 @@
             elif suffix == "w":
                 delta = datetime.timedelta(0, 0, 0, 0, 0, 0, value)
             else:
-                raise ValueError("Unknown suffix {!r}"
+                raise ValueError("Unknown suffix {0!r}"
                                  .format(suffix))
         except IndexError as e:
             raise ValueError(*(e.args))
@@ -2284,7 +2280,8 @@
         # Close all standard open file descriptors
         null = os.open(os.devnull, os.O_NOCTTY | os.O_RDWR)
         if not stat.S_ISCHR(os.fstat(null).st_mode):
-            raise OSError(errno.ENODEV, "{} not a character device"
+            raise OSError(errno.ENODEV,
+                          "{0} not a character device"
                           .format(os.devnull))
         os.dup2(null, sys.stdin.fileno())
         os.dup2(null, sys.stdout.fileno())
@@ -2300,7 +2297,7 @@
     
     parser = argparse.ArgumentParser()
     parser.add_argument("-v", "--version", action="version",
-                        version = "%(prog)s {}".format(version),
+                        version = "%(prog)s {0}".format(version),
                         help="show version number and exit")
     parser.add_argument("-i", "--interface", metavar="IF",
                         help="Bind to interface IF")
@@ -2339,9 +2336,6 @@
                         help="Directory to save/restore state in")
     parser.add_argument("--foreground", action="store_true",
                         help="Run in foreground", default=None)
-    parser.add_argument("--no-zeroconf", action="store_false",
-                        dest="zeroconf", help="Do not use Zeroconf",
-                        default=None)
     
     options = parser.parse_args()
     
@@ -2365,7 +2359,6 @@
                         "socket": "",
                         "statedir": "/var/lib/mandos",
                         "foreground": "False",
-                        "zeroconf": "True",
                         }
     
     # Parse config file for server-global settings
@@ -2398,19 +2391,18 @@
     for option in ("interface", "address", "port", "debug",
                    "priority", "servicename", "configdir",
                    "use_dbus", "use_ipv6", "debuglevel", "restore",
-                   "statedir", "socket", "foreground", "zeroconf"):
+                   "statedir", "socket", "foreground"):
         value = getattr(options, option)
         if value is not None:
             server_settings[option] = value
     del options
     # Force all strings to be unicode
     for option in server_settings.keys():
-        if isinstance(server_settings[option], bytes):
-            server_settings[option] = (server_settings[option]
-                                       .decode("utf-8"))
+        if type(server_settings[option]) is str:
+            server_settings[option] = unicode(server_settings[option])
     # Force all boolean options to be boolean
     for option in ("debug", "use_dbus", "use_ipv6", "restore",
-                   "foreground", "zeroconf"):
+                   "foreground"):
         server_settings[option] = bool(server_settings[option])
     # Debug implies foreground
     if server_settings["debug"]:
@@ -2419,12 +2411,6 @@
     
     ##################################################################
     
-    if (not server_settings["zeroconf"] and
-        not (server_settings["port"]
-             or server_settings["socket"] != "")):
-            parser.error("Needs port or socket to work without"
-                         " Zeroconf")
-    
     # For convenience
     debug = server_settings["debug"]
     debuglevel = server_settings["debuglevel"]
@@ -2433,7 +2419,6 @@
     stored_state_path = os.path.join(server_settings["statedir"],
                                      stored_state_file)
     foreground = server_settings["foreground"]
-    zeroconf = server_settings["zeroconf"]
     
     if debug:
         initlogger(debug, logging.DEBUG)
@@ -2446,7 +2431,7 @@
     
     if server_settings["servicename"] != "Mandos":
         syslogger.setFormatter(logging.Formatter
-                               ('Mandos ({}) [%(process)d]:'
+                               ('Mandos ({0}) [%(process)d]:'
                                 ' %(levelname)s: %(message)s'
                                 .format(server_settings
                                         ["servicename"])))
@@ -2460,9 +2445,6 @@
     global mandos_dbus_service
     mandos_dbus_service = None
     
-    socketfd = None
-    if server_settings["socket"] != "":
-        socketfd = server_settings["socket"]
     tcp_server = MandosServer((server_settings["address"],
                                server_settings["port"]),
                               ClientHandler,
@@ -2472,7 +2454,8 @@
                               gnutls_priority=
                               server_settings["priority"],
                               use_dbus=use_dbus,
-                              socketfd=socketfd)
+                              socketfd=(server_settings["socket"]
+                                        or None))
     if not foreground:
         pidfilename = "/run/mandos.pid"
         if not os.path.isdir("/run/."):
@@ -2548,16 +2531,14 @@
             use_dbus = False
             server_settings["use_dbus"] = False
             tcp_server.use_dbus = False
-    if zeroconf:
-        protocol = avahi.PROTO_INET6 if use_ipv6 else avahi.PROTO_INET
-        service = AvahiServiceToSyslog(name =
-                                       server_settings["servicename"],
-                                       servicetype = "_mandos._tcp",
-                                       protocol = protocol, bus = bus)
-        if server_settings["interface"]:
-            service.interface = (if_nametoindex
-                                 (server_settings["interface"]
-                                  .encode("utf-8")))
+    protocol = avahi.PROTO_INET6 if use_ipv6 else avahi.PROTO_INET
+    service = AvahiServiceToSyslog(name =
+                                   server_settings["servicename"],
+                                   servicetype = "_mandos._tcp",
+                                   protocol = protocol, bus = bus)
+    if server_settings["interface"]:
+        service.interface = (if_nametoindex
+                             (str(server_settings["interface"])))
     
     global multiprocessing_manager
     multiprocessing_manager = multiprocessing.Manager()
@@ -2587,7 +2568,7 @@
             os.remove(stored_state_path)
         except IOError as e:
             if e.errno == errno.ENOENT:
-                logger.warning("Could not load persistent state: {}"
+                logger.warning("Could not load persistent state: {0}"
                                 .format(os.strerror(e.errno)))
             else:
                 logger.critical("Could not load persistent state:",
@@ -2598,7 +2579,7 @@
                            "EOFError:", exc_info=e)
     
     with PGPEngine() as pgp:
-        for client_name, client in clients_data.items():
+        for client_name, client in clients_data.iteritems():
             # Skip removed clients
             if client_name not in client_settings:
                 continue
@@ -2629,14 +2610,14 @@
                 if datetime.datetime.utcnow() >= client["expires"]:
                     if not client["last_checked_ok"]:
                         logger.warning(
-                            "disabling client {} - Client never "
+                            "disabling client {0} - Client never "
                             "performed a successful checker"
                             .format(client_name))
                         client["enabled"] = False
                     elif client["last_checker_status"] != 0:
                         logger.warning(
-                            "disabling client {} - Client last"
-                            " checker failed with error code {}"
+                            "disabling client {0} - Client "
+                            "last checker failed with error code {1}"
                             .format(client_name,
                                     client["last_checker_status"]))
                         client["enabled"] = False
@@ -2645,7 +2626,7 @@
                                              .utcnow()
                                              + client["timeout"])
                         logger.debug("Last checker succeeded,"
-                                     " keeping {} enabled"
+                                     " keeping {0} enabled"
                                      .format(client_name))
             try:
                 client["secret"] = (
@@ -2654,7 +2635,7 @@
                                 ["secret"]))
             except PGPError:
                 # If decryption fails, we use secret from new settings
-                logger.debug("Failed to decrypt {} old secret"
+                logger.debug("Failed to decrypt {0} old secret"
                              .format(client_name))
                 client["secret"] = (
                     client_settings[client_name]["secret"])
@@ -2668,7 +2649,7 @@
         clients_data[client_name] = client_settings[client_name]
     
     # Create all client objects
-    for client_name, client in clients_data.items():
+    for client_name, client in clients_data.iteritems():
         tcp_server.clients[client_name] = client_class(
             name = client_name, settings = client,
             server_settings = server_settings)
@@ -2681,7 +2662,7 @@
             try:
                 with pidfile:
                     pid = os.getpid()
-                    pidfile.write("{}\n".format(pid).encode("utf-8"))
+                    pidfile.write(str(pid) + "\n".encode("utf-8"))
             except IOError:
                 logger.error("Could not write to file %r with PID %d",
                              pidfilename, pid)
@@ -2733,8 +2714,8 @@
             def GetAllClientsWithProperties(self):
                 "D-Bus method"
                 return dbus.Dictionary(
-                    { c.dbus_object_path: c.GetAll("")
-                      for c in tcp_server.clients.itervalues() },
+                    ((c.dbus_object_path, c.GetAll(""))
+                     for c in tcp_server.clients.itervalues()),
                     signature="oa{sv}")
             
             @dbus.service.method(_interface, in_signature="o")
@@ -2757,8 +2738,7 @@
     
     def cleanup():
         "Cleanup function; run on exit"
-        if zeroconf:
-            service.cleanup()
+        service.cleanup()
         
         multiprocessing.active_children()
         wnull.close()
@@ -2778,8 +2758,8 @@
                 
                 # A list of attributes that can not be pickled
                 # + secret.
-                exclude = { "bus", "changedstate", "secret",
-                            "checker", "server_settings" }
+                exclude = set(("bus", "changedstate", "secret",
+                               "checker", "server_settings"))
                 for name, typ in (inspect.getmembers
                                   (dbus.service.Object)):
                     exclude.add(name)
@@ -2808,7 +2788,7 @@
                 except NameError:
                     pass
             if e.errno in (errno.ENOENT, errno.EACCES, errno.EEXIST):
-                logger.warning("Could not save persistent state: {}"
+                logger.warning("Could not save persistent state: {0}"
                                .format(os.strerror(e.errno)))
             else:
                 logger.warning("Could not save persistent state:",
@@ -2843,8 +2823,7 @@
     tcp_server.server_activate()
     
     # Find out what port we got
-    if zeroconf:
-        service.port = tcp_server.socket.getsockname()[1]
+    service.port = tcp_server.socket.getsockname()[1]
     if use_ipv6:
         logger.info("Now listening on address %r, port %d,"
                     " flowinfo %d, scope_id %d",
@@ -2856,15 +2835,14 @@
     #service.interface = tcp_server.socket.getsockname()[3]
     
     try:
-        if zeroconf:
-            # From the Avahi example code
-            try:
-                service.activate()
-            except dbus.exceptions.DBusException as error:
-                logger.critical("D-Bus Exception", exc_info=error)
-                cleanup()
-                sys.exit(1)
-            # End of Avahi example code
+        # From the Avahi example code
+        try:
+            service.activate()
+        except dbus.exceptions.DBusException as error:
+            logger.critical("D-Bus Exception", exc_info=error)
+            cleanup()
+            sys.exit(1)
+        # End of Avahi example code
         
         gobject.io_add_watch(tcp_server.fileno(), gobject.IO_IN,
                              lambda *args, **kwargs:

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2014-06-22 02:19:30 +0000
+++ mandos-clients.conf.xml	2013-10-20 15:25:09 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2014-06-22">
+<!ENTITY TIMESTAMP "2013-10-15">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -177,13 +177,7 @@
 	    <varname>PATH</varname> will be searched.  The default
 	    value for the checker command is <quote><literal
 	    ><command>fping</command> <option>-q</option> <option
-	    >--</option> %%(host)s</literal></quote>.  Note that
-	    <command>mandos-keygen</command>, when generating output
-	    to be inserted into this file, normally looks for an SSH
-	    server on the Mandos client, and, if it find one, outputs
-	    a <option>checker</option> option to check for the
-	    client’s key fingerprint – this is more secure against
-	    spoofing.
+	    >--</option> %%(host)s</literal></quote>.
 	  </para>
 	  <para>
 	    In addition to normal start time expansion, this option

=== modified file 'mandos-ctl'
--- mandos-ctl	2014-10-05 20:08:58 +0000
+++ mandos-ctl	2014-03-01 09:39:25 +0000
@@ -26,10 +26,7 @@
 from __future__ import (division, absolute_import, print_function,
                         unicode_literals)
 
-try:
-    from future_builtins import *
-except ImportError:
-    pass
+from future_builtins import *
 
 import sys
 import argparse
@@ -42,9 +39,6 @@
 
 import dbus
 
-if sys.version_info.major == 2:
-    str = unicode
-
 locale.setlocale(locale.LC_ALL, "")
 
 tablewords = {
@@ -72,12 +66,18 @@
 server_path = "/"
 server_interface = domain + ".Mandos"
 client_interface = domain + ".Mandos.Client"
-version = "1.6.9"
+version = "1.6.4"
+
+def timedelta_to_milliseconds(td):
+    """Convert a datetime.timedelta object to milliseconds"""
+    return ((td.days * 24 * 60 * 60 * 1000)
+            + (td.seconds * 1000)
+            + (td.microseconds // 1000))
 
 def milliseconds_to_string(ms):
     td = datetime.timedelta(0, 0, 0, ms)
     return ("{days}{hours:02}:{minutes:02}:{seconds:02}"
-            .format(days = "{}T".format(td.days) if td.days else "",
+            .format(days = "{0}T".format(td.days) if td.days else "",
                     hours = td.seconds // 3600,
                     minutes = (td.seconds % 3600) // 60,
                     seconds = td.seconds % 60,
@@ -151,11 +151,11 @@
     token_duration = Token(re.compile(r"P"), None,
                            frozenset((token_year, token_month,
                                       token_day, token_time,
-                                      token_week)))
+                                      token_week))),
     # Define starting values
     value = datetime.timedelta() # Value so far
     found_token = None
-    followers = frozenset((token_duration,)) # Following valid tokens
+    followers = frozenset(token_duration,) # Following valid tokens
     s = duration                # String left to parse
     # Loop until end token is found
     while found_token is not token_end:
@@ -230,7 +230,7 @@
         if keyword in ("Timeout", "Interval", "ApprovalDelay",
                        "ApprovalDuration", "ExtendedTimeout"):
             return milliseconds_to_string(value)
-        return str(value)
+        return unicode(value)
     
     # Create format string to print table rows
     format_string = " ".join("{{{key}:{width}}}".format(
@@ -243,10 +243,10 @@
     # Print header line
     print(format_string.format(**tablewords))
     for client in clients:
-        print(format_string.format(**{ key:
+        print(format_string.format(**dict((key,
                                            valuetostring(client[key],
-                                                         key)
-                                       for key in keywords }))
+                                                         key))
+                                          for key in keywords)))
 
 def has_actions(options):
     return any((options.enable,
@@ -271,7 +271,7 @@
 def main():
     parser = argparse.ArgumentParser()
     parser.add_argument("--version", action="version",
-                        version = "%(prog)s {}".format(version),
+                        version = "%(prog)s {0}".format(version),
                         help="show version number and exit")
     parser.add_argument("-a", "--all", action="store_true",
                         help="Select all clients")
@@ -310,8 +310,7 @@
     parser.add_argument("--approval-duration",
                         help="Set duration of one client approval")
     parser.add_argument("-H", "--host", help="Set host for client")
-    parser.add_argument("-s", "--secret",
-                        type=argparse.FileType(mode="rb"),
+    parser.add_argument("-s", "--secret", type=file,
                         help="Set password blob (file) for client")
     parser.add_argument("-A", "--approve", action="store_true",
                         help="Approve any current client request")
@@ -366,17 +365,18 @@
     clients={}
     
     if options.all or not options.client:
-        clients = { bus.get_object(busname, path): properties
-                    for path, properties in mandos_clients.items() }
+        clients = dict((bus.get_object(busname, path), properties)
+                       for path, properties in
+                       mandos_clients.iteritems())
     else:
         for name in options.client:
-            for path, client in mandos_clients.items():
+            for path, client in mandos_clients.iteritems():
                 if client["Name"] == name:
                     client_objc = bus.get_object(busname, path)
                     clients[client_objc] = client
                     break
             else:
-                print("Client not found on server: {!r}"
+                print("Client not found on server: {0!r}"
                       .format(name), file=sys.stderr)
                 sys.exit(1)
     
@@ -405,8 +405,8 @@
                 """Set a Client D-Bus property, converted
                 from a string to milliseconds."""
                 set_client_prop(prop,
-                                string_to_delta(value).total_seconds()
-                                * 1000)
+                                timedelta_to_milliseconds
+                                (string_to_delta(value)))
             if options.remove:
                 mandos_serv.RemoveClient(client.__dbus_object_path__)
             if options.enable:

=== modified file 'mandos-keygen'
--- mandos-keygen	2014-10-05 20:08:58 +0000
+++ mandos-keygen	2014-03-01 09:51:07 +0000
@@ -2,8 +2,8 @@
 # 
 # Mandos key generator - create a new OpenPGP key for a Mandos client
 # 
-# Copyright © 2008-2014 Teddy Hogeborn
-# Copyright © 2008-2014 Björn Påhlsson
+# Copyright © 2008-2013 Teddy Hogeborn
+# Copyright © 2008-2013 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@recompile.se>.
 # 
 
-VERSION="1.6.9"
+VERSION="1.6.4"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=RSA
@@ -33,7 +33,6 @@
 KEYCOMMENT=""
 KEYEXPIRE=0
 FORCE=no
-SSH=yes
 KEYCOMMENT_ORIG="$KEYCOMMENT"
 mode=keygen
 
@@ -42,8 +41,8 @@
 fi
 
 # Parse options
-TEMP=`getopt --options vhpF:d:t:l:s:L:n:e:c:x:fS \
-    --longoptions version,help,password,passfile:,dir:,type:,length:,subtype:,sublength:,name:,email:,comment:,expire:,force,no-ssh \
+TEMP=`getopt --options vhpF:d:t:l:s:L:n:e:c:x:f \
+    --longoptions version,help,password,passfile:,dir:,type:,length:,subtype:,sublength:,name:,email:,comment:,expire:,force \
     --name "$0" -- "$@"`
 
 help(){
@@ -86,7 +85,6 @@
                         Encrypt a password from FILE using the key in
                         the key directory.  All options other than
                         --dir and --name are ignored.
-  -S, --no-ssh          Don't get SSH key or set "checker" option.
 EOF
 }
 
@@ -105,7 +103,6 @@
 	-c|--comment) KEYCOMMENT="$2"; shift 2;;
 	-x|--expire) KEYEXPIRE="$2"; shift 2;;
 	-f|--force) FORCE=yes; shift;;
-	-S|--no-ssh) SSH=no; shift;;
 	-v|--version) echo "$0 $VERSION"; exit;;
 	-h|--help) help; exit;;
 	--) shift; break;;
@@ -191,7 +188,7 @@
 trap "
 set +e; \
 test -n \"$SECFILE\" && shred --remove \"$SECFILE\"; \
-shred --remove \"$RINGDIR\"/sec* 2>/dev/null;
+shred --remove \"$RINGDIR\"/sec*;
 test -n \"$BATCHFILE\" && rm --force \"$BATCHFILE\"; \
 rm --recursive --force \"$RINGDIR\";
 tty --quiet && stty echo; \
@@ -277,23 +274,6 @@
 fi
 
 if [ "$mode" = password ]; then
-    
-    # Make SSH be 0 or 1
-    case "$SSH" in
-	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]) SSH=1;;
-	[Nn][Oo]|[Ff][Aa][Ll][Ss][Ee]|*) SSH=0;;
-    esac
-    
-    if [ $SSH -eq 1 ]; then
-	set +e
-	ssh_fingerprint="`ssh-keyscan localhost 2>/dev/null`"
-	if [ $? -ne 0 ]; then
-	    ssh_fingerprint=""
-	fi
-	set -e
-	ssh_fingerprint="${ssh_fingerprint#localhost }"
-    fi
-    
     # Import key into temporary key rings
     gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
 	--homedir "$RINGDIR" --trust-model always --armor \
@@ -362,10 +342,6 @@
 		/^[^-]/s/^/    /p
 	    }
 	}' < "$SECFILE"
-    if [ -n "$ssh_fingerprint" ]; then
-	echo 'checker = ssh-keyscan %%(host)s 2>/dev/null | grep --fixed-strings --line-regexp --quiet --regexp=%%(host)s" %(ssh_fingerprint)s"'
-	echo "ssh_fingerprint = ${ssh_fingerprint}"
-    fi
 fi
 
 trap - EXIT
@@ -376,5 +352,5 @@
     shred --remove "$SECFILE"
 fi
 # Remove the key rings
-shred --remove "$RINGDIR"/sec* 2>/dev/null
+shred --remove "$RINGDIR"/sec*
 rm --recursive --force "$RINGDIR"

=== modified file 'mandos-keygen.xml'
--- mandos-keygen.xml	2014-06-22 02:19:30 +0000
+++ mandos-keygen.xml	2013-10-22 19:24:01 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-keygen">
-<!ENTITY TIMESTAMP "2014-06-22">
+<!ENTITY TIMESTAMP "2013-10-22">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -119,10 +119,7 @@
 	<replaceable>TIME</replaceable></option></arg>
       </group>
       <sbr/>
-      <group>
-	<arg choice="plain"><option>--force</option></arg>
-	<arg choice="plain"><option>-f</option></arg>
-      </group>
+      <arg><option>--force</option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -148,10 +145,6 @@
 	<arg choice="plain"><option>-n
 	<replaceable>NAME</replaceable></option></arg>
       </group>
-      <group>
-	<arg choice="plain"><option>--no-ssh</option></arg>
-	<arg choice="plain"><option>-S</option></arg>
-      </group>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -353,22 +346,6 @@
 	  </para>
 	</listitem>
       </varlistentry>
-      <varlistentry>
-	<term><option>--no-ssh</option></term>
-	<term><option>-S</option></term>
-	<listitem>
-	  <para>
-	    When <option>--password</option> or
-	    <option>--passfile</option> is given, this option will
-	    prevent <command>&COMMANDNAME;</command> from calling
-	    <command>ssh-keyscan</command> to get an SSH fingerprint
-	    for this host and, if successful, output suitable config
-	    options to use this fingerprint as a
-	    <option>checker</option> option in the output.  This is
-	    otherwise the default behavior.
-	  </para>
-	</listitem>
-      </varlistentry>
     </variablelist>
   </refsect1>
   
@@ -525,9 +502,7 @@
       <citerefentry><refentrytitle>mandos</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos-client</refentrytitle>
-      <manvolnum>8mandos</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>ssh-keyscan</refentrytitle>
-      <manvolnum>1</manvolnum></citerefentry>
+      <manvolnum>8mandos</manvolnum></citerefentry>
     </para>
   </refsect1>
   

=== modified file 'mandos-monitor'
--- mandos-monitor	2014-10-05 20:08:58 +0000
+++ mandos-monitor	2014-03-01 09:39:25 +0000
@@ -48,7 +48,7 @@
 
 import locale
 
-if sys.version_info.major == 2:
+if sys.version_info[0] == 2:
     str = unicode
 
 locale.setlocale(locale.LC_ALL, '')
@@ -60,7 +60,7 @@
 domain = 'se.recompile'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.6.9"
+version = "1.6.4"
 
 def isoformat_to_datetime(iso):
     "Parse an ISO 8601 date string to a datetime.datetime()"
@@ -87,9 +87,9 @@
         self.proxy = proxy_object # Mandos Client proxy object
         self.properties = dict() if properties is None else properties
         self.property_changed_match = (
-            self.proxy.connect_to_signal("PropertiesChanged",
-                                         self.properties_changed,
-                                         dbus.PROPERTIES_IFACE,
+            self.proxy.connect_to_signal("PropertyChanged",
+                                         self._property_changed,
+                                         client_interface,
                                          byte_arrays=True))
         
         if properties is None:
@@ -100,12 +100,16 @@
         
         super(MandosClientPropertyCache, self).__init__(**kwargs)
     
-    def properties_changed(self, interface, properties, invalidated):
-        """This is called whenever we get a PropertiesChanged signal
-        It updates the changed properties in the "properties" dict.
+    def _property_changed(self, property, value):
+        """Helper which takes positional arguments"""
+        return self.property_changed(property=property, value=value)
+    
+    def property_changed(self, property=None, value=None):
+        """This is called whenever we get a PropertyChanged signal
+        It updates the changed property in the "properties" dict.
         """
         # Update properties dict with new value
-        self.properties.update(properties)
+        self.properties[property] = value
     
     def delete(self):
         self.property_changed_match.remove()
@@ -157,8 +161,8 @@
                                          self.rejected,
                                          client_interface,
                                          byte_arrays=True))
-        self.logger('Created client {}'
-                    .format(self.properties["Name"]), level=0)
+        #self.logger('Created client {0}'
+        #            .format(self.properties["Name"]))
     
     def using_timer(self, flag):
         """Call this method with True or False when timer should be
@@ -175,52 +179,51 @@
     
     def checker_completed(self, exitstatus, condition, command):
         if exitstatus == 0:
-            self.logger('Checker for client {} (command "{}")'
-                        ' succeeded'.format(self.properties["Name"],
-                                            command), level=0)
             self.update()
             return
         # Checker failed
         if os.WIFEXITED(condition):
-            self.logger('Checker for client {} (command "{}") failed'
-                        ' with exit code {}'
+            self.logger('Checker for client {0} (command "{1}")'
+                        ' failed with exit code {2}'
                         .format(self.properties["Name"], command,
                                 os.WEXITSTATUS(condition)))
         elif os.WIFSIGNALED(condition):
-            self.logger('Checker for client {} (command "{}") was'
-                        ' killed by signal {}'
+            self.logger('Checker for client {0} (command "{1}") was'
+                        ' killed by signal {2}'
                         .format(self.properties["Name"], command,
                                 os.WTERMSIG(condition)))
         elif os.WCOREDUMP(condition):
-            self.logger('Checker for client {} (command "{}") dumped'
-                        ' core'.format(self.properties["Name"],
-                                       command))
+            self.logger('Checker for client {0} (command "{1}")'
+                        ' dumped core'
+                        .format(self.properties["Name"], command))
         else:
-            self.logger('Checker for client {} completed'
+            self.logger('Checker for client {0} completed'
                         ' mysteriously'
                         .format(self.properties["Name"]))
         self.update()
     
     def checker_started(self, command):
-        """Server signals that a checker started."""
-        self.logger('Client {} started checker "{}"'
-                    .format(self.properties["Name"],
-                            command), level=0)
+        """Server signals that a checker started. This could be useful
+           to log in the future. """
+        #self.logger('Client {0} started checker "{1}"'
+        #            .format(self.properties["Name"],
+        #                    str(command)))
+        pass
     
     def got_secret(self):
-        self.logger('Client {} received its secret'
+        self.logger('Client {0} received its secret'
                     .format(self.properties["Name"]))
     
     def need_approval(self, timeout, default):
         if not default:
-            message = 'Client {} needs approval within {} seconds'
+            message = 'Client {0} needs approval within {1} seconds'
         else:
-            message = 'Client {} will get its secret in {} seconds'
+            message = 'Client {0} will get its secret in {1} seconds'
         self.logger(message.format(self.properties["Name"],
                                    timeout/1000))
     
     def rejected(self, reason):
-        self.logger('Client {} was rejected; reason: {}'
+        self.logger('Client {0} was rejected; reason: {1}'
                     .format(self.properties["Name"], reason))
     
     def selectable(self):
@@ -270,9 +273,9 @@
             else:
                 timer = datetime.timedelta()
             if self.properties["ApprovedByDefault"]:
-                message = "Approval in {}. (d)eny?"
+                message = "Approval in {0}. (d)eny?"
             else:
-                message = "Denial in {}. (a)pprove?"
+                message = "Denial in {0}. (a)pprove?"
             message = message.format(str(timer).rsplit(".", 1)[0])
             self.using_timer(True)
         elif self.properties["LastCheckerStatus"] != 0:
@@ -286,13 +289,13 @@
                 timer = max(expires - datetime.datetime.utcnow(),
                             datetime.timedelta())
             message = ('A checker has failed! Time until client'
-                       ' gets disabled: {}'
+                       ' gets disabled: {0}'
                        .format(str(timer).rsplit(".", 1)[0]))
             self.using_timer(True)
         else:
             message = "enabled"
             self.using_timer(False)
-        self._text = "{}{}".format(base, message)
+        self._text = "{0}{1}".format(base, message)
         
         if not urwid.supports_unicode():
             self._text = self._text.encode("ascii", "replace")
@@ -373,15 +376,14 @@
         else:
             return key
     
-    def properties_changed(self, interface, properties, invalidated):
-        """Call self.update() if any properties changed.
+    def property_changed(self, property=None, **kwargs):
+        """Call self.update() if old value is not new value.
         This overrides the method from MandosClientPropertyCache"""
-        old_values = { key: self.properties.get(key)
-                       for key in properties.keys() }
-        super(MandosClientWidget, self).properties_changed(
-            interface, properties, invalidated)
-        if any(old_values[key] != self.properties.get(key)
-               for key in old_values):
+        property_name = str(property)
+        old_value = self.properties.get(property_name)
+        super(MandosClientWidget, self).property_changed(
+            property=property, **kwargs)
+        if self.properties.get(property_name) != old_value:
             self.update()
 
 
@@ -401,7 +403,7 @@
     """This is the entire user interface - the whole screen
     with boxes, lists of client widgets, etc.
     """
-    def __init__(self, max_log_length=1000, log_level=1):
+    def __init__(self, max_log_length=1000):
         DBusGMainLoop(set_as_default=True)
         
         self.screen = urwid.curses_display.Screen()
@@ -445,8 +447,6 @@
         self.log = []
         self.max_log_length = max_log_length
         
-        self.log_level = log_level
-        
         # We keep a reference to the log widget so we can remove it
         # from the ListWalker without it getting destroyed
         self.logbox = ConstrainedListBox(self.log)
@@ -466,8 +466,8 @@
         self.main_loop = gobject.MainLoop()
     
     def client_not_found(self, fingerprint, address):
-        self.log_message("Client with address {} and fingerprint {}"
-                         " could not be found"
+        self.log_message("Client with address {0} and fingerprint"
+                         " {1} could not be found"
                          .format(address, fingerprint))
     
     def rebuild(self):
@@ -486,18 +486,13 @@
             self.uilist.append(self.logbox)
         self.topwidget = urwid.Pile(self.uilist)
     
-    def log_message(self, message, level=1):
+    def log_message(self, message):
         """Log message formatted with timestamp"""
-        if level < self.log_level:
-            return
         timestamp = datetime.datetime.now().isoformat()
-        self.log_message_raw("{}: {}".format(timestamp, message),
-                             level=level)
+        self.log_message_raw(timestamp + ": " + message)
     
-    def log_message_raw(self, markup, level=1):
+    def log_message_raw(self, markup):
         """Add a log message to the log buffer."""
-        if level < self.log_level:
-            return
         self.log.append(urwid.Text(markup, wrap=self.log_wrap))
         if (self.max_log_length
             and len(self.log) > self.max_log_length):
@@ -510,8 +505,8 @@
         """Toggle visibility of the log buffer."""
         self.log_visible = not self.log_visible
         self.rebuild()
-        self.log_message("Log visibility changed to: {}"
-                         .format(self.log_visible), level=0)
+        #self.log_message("Log visibility changed to: "
+        #                 + str(self.log_visible))
     
     def change_log_display(self):
         """Change type of log display.
@@ -522,8 +517,7 @@
             self.log_wrap = "clip"
         for textwidget in self.log:
             textwidget.set_wrap_mode(self.log_wrap)
-        self.log_message("Wrap mode: {}".format(self.log_wrap),
-                         level=0)
+        #self.log_message("Wrap mode: " + self.log_wrap)
     
     def find_and_remove_client(self, path, name):
         """Find a client by its object path and remove it.
@@ -534,7 +528,7 @@
             client = self.clients_dict[path]
         except KeyError:
             # not found?
-            self.log_message("Unknown client {!r} ({!r}) removed"
+            self.log_message("Unknown client {0!r} ({1!r}) removed"
                              .format(name, path))
             return
         client.delete()
@@ -658,8 +652,7 @@
             elif key == "window resize":
                 self.size = self.screen.get_cols_rows()
                 self.refresh()
-            elif key == "ctrl l":
-                self.screen.clear()
+            elif key == "\f":  # Ctrl-L
                 self.refresh()
             elif key == "l" or key == "D":
                 self.toggle_log_display()
@@ -677,9 +670,7 @@
                                             "?: Help",
                                             "l: Log window toggle",
                                             "TAB: Switch window",
-                                            "w: Wrap (log lines)",
-                                            "v: Toggle verbose log",
-                                            ))))
+                                            "w: Wrap (log)"))))
                 self.log_message_raw(("bold",
                                       "  "
                                       .join(("Clients:",
@@ -698,13 +689,6 @@
                 else:
                     self.topwidget.set_focus(self.logbox)
                 self.refresh()
-            elif key == "v":
-                if self.log_level == 0:
-                    self.log_level = 1
-                    self.log_message("Verbose mode: Off")
-                else:
-                    self.log_level = 0
-                    self.log_message("Verbose mode: On")
             #elif (key == "end" or key == "meta >" or key == "G"
             #      or key == ">"):
             #    pass            # xxx end-of-buffer

=== modified file 'mandos-monitor.xml'
--- mandos-monitor.xml	2014-07-14 21:41:08 +0000
+++ mandos-monitor.xml	2011-12-31 23:05:34 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-monitor">
-<!ENTITY TIMESTAMP "2014-07-14">
+<!ENTITY TIMESTAMP "2012-01-01">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -129,10 +129,6 @@
 	<entry>Toggle log window line wrap</entry>
       </row>
       <row>
-	<entry>v</entry>
-	<entry>Toggle verbose logging</entry>
-      </row>
-      <row>
 	<entry>Up, Ctrl-P, k</entry>
 	<entry>Move up a line</entry>
       </row>

=== modified file 'mandos-options.xml'
--- mandos-options.xml	2014-06-15 02:48:49 +0000
+++ mandos-options.xml	2013-10-24 20:21:45 +0000
@@ -123,11 +123,4 @@
     implies this option.
   </para>
   
-  <para id="zeroconf">
-    This option controls whether the server will announce its
-    existence using Zeroconf.  Default is to use Zeroconf.  If
-    Zeroconf is not used, a <option>port</option> number or a
-    <option>socket</option> is required.
-  </para>
-  
 </section>

=== modified file 'mandos.conf'
--- mandos.conf	2014-06-15 02:48:49 +0000
+++ mandos.conf	2013-10-22 19:24:01 +0000
@@ -45,9 +45,3 @@
 
 # Whether to run in the foreground
 ;foreground = False
-
-# File descriptor number to use for network socket
-;socket = 
-
-# Whether to use ZeroConf; if false, requires port or socket
-;zeroconf = True

=== modified file 'mandos.lsm'
--- mandos.lsm	2014-10-05 20:08:58 +0000
+++ mandos.lsm	2014-02-16 14:22:03 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.6.9
-Entered-date:	2014-10-05
+Version:	1.6.4
+Entered-date:	2014-02-16
 Description:	The Mandos system allows computers to have encrypted
 		root file systems and at the same time be capable of
 		remote and/or unattended reboots.
@@ -11,13 +11,13 @@
 		belorn@recompile.se (Björn Påhlsson)
 Maintained-by:	teddy@recompile.se (Teddy Hogeborn),
 		belorn@recompile.se (Björn Påhlsson)
-Primary-site:	http://www.recompile.se/mandos
-		161K mandos_1.6.9.orig.tar.gz
-Alternate-site:	ftp://ftp.recompile.se/pub/mandos
-		161K mandos_1.6.9.orig.tar.gz
+Primary-site: http://www.recompile.se/mandos
+	      158K mandos_1.6.4.orig.tar.gz
+Alternate-site: ftp://ftp.recompile.se/pub/mandos
+		158K mandos_1.6.4.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.6, and
 		various other libraries.  While made for Debian
 		GNU/Linux, it is probably portable to other
-		distributions, but not other Unixes.
-Copying-policy:	GNU General Public License version 3.0 or later
+		distributions, but not other Unixes. 
+Copying-policy: GNU General Public License version 3.0 or later
 End

=== modified file 'mandos.service'
--- mandos.service	2014-10-05 19:39:25 +0000
+++ mandos.service	2013-12-31 16:02:18 +0000
@@ -1,13 +1,12 @@
 [Unit]
 Description=Server of encrypted passwords to Mandos clients
-Documentation=man:intro(8mandos) man:mandos(8)
 
 [Service]
 Type=simple
 ## Type=dbus is not appropriate, because Mandos also needs to announce
 ## its ZeroConf service and be reachable on the network.
 #Type=dbus
-#BusName=se.recompile.Mandos
+BusName=se.recompile.Mandos
 # If you add --no-dbus, also comment out BusName above, and vice versa
 ExecStart=/usr/sbin/mandos --foreground
 Restart=always

=== modified file 'mandos.xml'
--- mandos.xml	2014-06-15 02:48:49 +0000
+++ mandos.xml	2013-10-26 19:05:21 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2014-06-15">
+<!ENTITY TIMESTAMP "2013-10-26">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -106,8 +106,6 @@
       <replaceable>FD</replaceable></option></arg>
       <sbr/>
       <arg><option>--foreground</option></arg>
-      <sbr/>
-      <arg><option>--no-zeroconf</option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -325,13 +323,6 @@
 	</listitem>
       </varlistentry>
       
-      <varlistentry>
-	<term><option>--no-zeroconf</option></term>
-	<listitem>
-	  <xi:include href="mandos-options.xml" xpointer="zeroconf"/>
-	</listitem>
-      </varlistentry>
-      
     </variablelist>
   </refsect1>
   

=== removed directory 'plugin-helpers'
=== modified file 'plugin-runner.c'
--- plugin-runner.c	2015-06-28 16:35:27 +0000
+++ plugin-runner.c	2014-03-27 21:24:33 +0000
@@ -2,8 +2,8 @@
 /*
  * Mandos plugin runner - Run Mandos plugins
  *
- * Copyright © 2008-2014 Teddy Hogeborn
- * Copyright © 2008-2014 Björn Påhlsson
+ * Copyright © 2008-2013 Teddy Hogeborn
+ * Copyright © 2008-2013 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -23,17 +23,18 @@
  */
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY(), getline(),
-				   O_CLOEXEC, pipe2() */
+				   O_CLOEXEC */
 #include <stddef.h>		/* size_t, NULL */
 #include <stdlib.h>		/* malloc(), exit(), EXIT_SUCCESS,
 				   realloc() */
 #include <stdbool.h>		/* bool, true, false */
 #include <stdio.h>		/* fileno(), fprintf(),
 				   stderr, STDOUT_FILENO, fclose() */
-#include <sys/types.h>	        /* fstat(), struct stat, waitpid(),
-				   WIFEXITED(), WEXITSTATUS(), wait(),
-				   pid_t, uid_t, gid_t, getuid(),
-				   getgid() */
+#include <sys/types.h>	        /* DIR, fdopendir(), fstat(), struct
+				   stat, waitpid(), WIFEXITED(),
+				   WEXITSTATUS(), wait(), pid_t,
+				   uid_t, gid_t, getuid(), getgid(),
+				   dirfd() */
 #include <sys/select.h>		/* fd_set, select(), FD_ZERO(),
 				   FD_SET(), FD_ISSET(), FD_CLR */
 #include <sys/wait.h>		/* wait(), waitpid(), WIFEXITED(),
@@ -41,17 +42,17 @@
 				   WCOREDUMP() */
 #include <sys/stat.h>		/* struct stat, fstat(), S_ISREG() */
 #include <iso646.h>		/* and, or, not */
-#include <dirent.h>		/* struct dirent, scandirat() */
+#include <dirent.h>		/* DIR, struct dirent, fdopendir(),
+				   readdir(), closedir(), dirfd() */
 #include <unistd.h>		/* fcntl(), F_GETFD, F_SETFD,
 				   FD_CLOEXEC, write(), STDOUT_FILENO,
 				   struct stat, fstat(), close(),
 				   setgid(), setuid(), S_ISREG(),
-				   faccessat() pipe2(), fork(),
+				   faccessat() pipe(), fork(),
 				   _exit(), dup2(), fexecve(), read()
 				*/
 #include <fcntl.h>		/* fcntl(), F_GETFD, F_SETFD,
-				   FD_CLOEXEC, openat(), scandirat(),
-				   pipe2() */
+				   FD_CLOEXEC, openat() */
 #include <string.h>		/* strsep, strlen(), strsignal(),
 				   strcmp(), strncmp() */
 #include <errno.h>		/* errno */
@@ -76,7 +77,6 @@
 #define BUFFER_SIZE 256
 
 #define PDIR "/lib/mandos/plugins.d"
-#define PHDIR "/lib/mandos/plugin-helpers"
 #define AFILE "/conf/conf.d/mandos/plugin-runner.conf"
 
 const char *argp_program_version = "plugin-runner " VERSION;
@@ -241,7 +241,6 @@
   return add_to_char_array(def, &(p->environ), &(p->envc));
 }
 
-#ifndef O_CLOEXEC
 /*
  * Based on the example in the GNU LibC manual chapter 13.13 "File
  * Descriptor Flags".
@@ -258,7 +257,6 @@
   return (int)TEMP_FAILURE_RETRY(fcntl(fd, F_SETFD,
 				       ret | FD_CLOEXEC));
 }
-#endif	/* not O_CLOEXEC */
 
 
 /* Mark processes as completed when they exit, and save their exit
@@ -348,10 +346,10 @@
 
 int main(int argc, char *argv[]){
   char *plugindir = NULL;
-  char *pluginhelperdir = NULL;
   char *argfile = NULL;
   FILE *conffp;
-  struct dirent **direntries = NULL;
+  DIR *dir = NULL;
+  struct dirent *dirst;
   struct stat st;
   fd_set rfds_all;
   int ret, maxfd = 0;
@@ -365,7 +363,7 @@
 				      .sa_flags = SA_NOCLDSTOP };
   char **custom_argv = NULL;
   int custom_argc = 0;
-  int dir_fd = -1;
+  int dir_fd;
   
   /* Establish a signal handler */
   sigemptyset(&sigchld_action.sa_mask);
@@ -416,10 +414,6 @@
       .doc = "Group ID the plugins will run as", .group = 3 },
     { .name = "debug", .key = 132,
       .doc = "Debug mode", .group = 4 },
-    { .name = "plugin-helper-dir", .key = 133,
-      .arg = "DIRECTORY",
-      .doc = "Specify a different plugin helper directory",
-      .group = 2 },
     /*
      * These reproduce what we would get without ARGP_NO_HELP
      */
@@ -551,13 +545,6 @@
     case 132:			/* --debug */
       debug = true;
       break;
-    case 133:			/* --plugin-helper-dir */
-      free(pluginhelperdir);
-      pluginhelperdir = strdup(arg);
-      if(pluginhelperdir != NULL){
-	errno = 0;
-      }
-      break;
       /*
        * These reproduce what we would get without ARGP_NO_HELP
        */
@@ -614,7 +601,6 @@
     case 130:			/* --userid */
     case 131:			/* --groupid */
     case 132:			/* --debug */
-    case 133:			/* --plugin-helper-dir */
     case '?':			/* --help */
     case -3:			/* --usage */
     case 'V':			/* --version */
@@ -775,24 +761,6 @@
     goto fallback;
   }
   
-  {
-    char *pluginhelperenv;
-    bool bret = true;
-    ret = asprintf(&pluginhelperenv, "MANDOSPLUGINHELPERDIR=%s",
-		   pluginhelperdir != NULL ? pluginhelperdir : PHDIR);
-    if(ret != -1){
-      bret = add_environment(getplugin(NULL), pluginhelperenv, true);
-    }
-    if(ret == -1 or not bret){
-      error(0, errno, "Failed to set MANDOSPLUGINHELPERDIR"
-	    " environment variable to \"%s\" for all plugins\n",
-	    pluginhelperdir != NULL ? pluginhelperdir : PHDIR);
-    }
-    if(ret != -1){
-      free(pluginhelperenv);
-    }
-  }
-  
   if(debug){
     for(plugin *p = plugin_list; p != NULL; p=p->next){
       fprintf(stderr, "Plugin: %s has %d arguments\n",
@@ -861,104 +829,122 @@
     ret = set_cloexec_flag(dir_fd);
     if(ret < 0){
       error(0, errno, "set_cloexec_flag");
+      TEMP_FAILURE_RETRY(close(dir_fd));
       exitstatus = EX_OSERR;
       goto fallback;
     }
 #endif	/* O_CLOEXEC */
+    
+    dir = fdopendir(dir_fd);
+    if(dir == NULL){
+      error(0, errno, "Could not open plugin dir");
+      TEMP_FAILURE_RETRY(close(dir_fd));
+      exitstatus = EX_OSERR;
+      goto fallback;
+    }
   }
   
-  int good_name(const struct dirent * const dirent){
-    const char * const patterns[] = { ".*", "#*#", "*~", "*.dpkg-new",
-				      "*.dpkg-old", "*.dpkg-bak",
-				      "*.dpkg-divert", NULL };
+  FD_ZERO(&rfds_all);
+  
+  /* Read and execute any executable in the plugin directory*/
+  while(true){
+    do {
+      dirst = readdir(dir);
+    } while(dirst == NULL and errno == EINTR);
+    
+    /* All directory entries have been processed */
+    if(dirst == NULL){
+      if(errno == EBADF){
+	error(0, errno, "readdir");
+	exitstatus = EX_IOERR;
+	goto fallback;
+      }
+      break;
+    }
+    
+    /* Ignore dotfiles, backup files and other junk */
+    {
+      bool bad_name = false;
+      const char * const patterns[] = { ".*", "#*#", "*~",
+					"*.dpkg-new", "*.dpkg-old",
+					"*.dpkg-bak", "*.dpkg-divert",
+					NULL };
 #ifdef __GNUC__
 #pragma GCC diagnostic push
 #pragma GCC diagnostic ignored "-Wcast-qual"
 #endif
-    for(const char **pat = (const char **)patterns;
-	*pat != NULL; pat++){
+      for(const char **pat = (const char **)patterns;
+	  *pat != NULL; pat++){
 #ifdef __GNUC__
 #pragma GCC diagnostic pop
 #endif
-      if(fnmatch(*pat, dirent->d_name, FNM_FILE_NAME | FNM_PERIOD)
-	 != FNM_NOMATCH){
-	if(debug){
+	if(fnmatch(*pat, dirst->d_name,
+		   FNM_FILE_NAME | FNM_PERIOD) != FNM_NOMATCH){
+	  if(debug){
 	    fprintf(stderr, "Ignoring plugin dir entry \"%s\""
-		    " matching pattern %s\n", dirent->d_name, *pat);
+		    " matching pattern %s\n", dirst->d_name, *pat);
+	  }
+	  bad_name = true;
+	  break;
 	}
-	return 0;
+      }
+      if(bad_name){
+	continue;
       }
     }
-    return 1;
-  }
-  
-#ifdef __GLIBC__
-#if __GLIBC_PREREQ(2, 15)
-  int numplugins = scandirat(dir_fd, ".", &direntries, good_name,
-			     alphasort);
-#else  /* not __GLIBC_PREREQ(2, 15) */
-  int numplugins = scandir(plugindir != NULL ? plugindir : PDIR,
-			   &direntries, good_name, alphasort);
-#endif	/* not __GLIBC_PREREQ(2, 15) */
-#else	/* not __GLIBC__ */
-  int numplugins = scandir(plugindir != NULL ? plugindir : PDIR,
-			   &direntries, good_name, alphasort);
-#endif	/* not __GLIBC__ */
-  if(numplugins == -1){
-    error(0, errno, "Could not scan plugin dir");
-    direntries = NULL;
-    exitstatus = EX_OSERR;
-    goto fallback;
-  }
-  
-  FD_ZERO(&rfds_all);
-  
-  /* Read and execute any executable in the plugin directory*/
-  for(int i = 0; i < numplugins; i++){
     
-    int plugin_fd = openat(dir_fd, direntries[i]->d_name, O_RDONLY);
+    int plugin_fd = openat(dir_fd, dirst->d_name, O_RDONLY |
+#ifdef O_CLOEXEC
+			    O_CLOEXEC
+#else  /* not O_CLOEXEC */
+			    0
+#endif	/* not O_CLOEXEC */
+			    );
     if(plugin_fd == -1){
       error(0, errno, "Could not open plugin");
-      free(direntries[i]);
-      continue;
-    }
+      continue;
+    }
+#ifndef O_CLOEXEC
+  /* Set the FD_CLOEXEC flag on the plugin FD */
+    ret = set_cloexec_flag(plugin_fd);
+    if(ret < 0){
+      error(0, errno, "set_cloexec_flag");
+      TEMP_FAILURE_RETRY(close(plugin_fd));
+      continue;
+    }
+#endif	/* O_CLOEXEC */
     ret = (int)TEMP_FAILURE_RETRY(fstat(plugin_fd, &st));
     if(ret == -1){
       error(0, errno, "stat");
       TEMP_FAILURE_RETRY(close(plugin_fd));
-      free(direntries[i]);
       continue;
     }
     
     /* Ignore non-executable files */
     if(not S_ISREG(st.st_mode)
-       or (TEMP_FAILURE_RETRY(faccessat(dir_fd, direntries[i]->d_name,
-					X_OK, 0)) != 0)){
+       or (TEMP_FAILURE_RETRY(faccessat(dir_fd, dirst->d_name, X_OK,
+					0)) != 0)){
       if(debug){
 	fprintf(stderr, "Ignoring plugin dir entry \"%s/%s\""
 		" with bad type or mode\n",
-		plugindir != NULL ? plugindir : PDIR,
-		direntries[i]->d_name);
+		plugindir != NULL ? plugindir : PDIR, dirst->d_name);
       }
       TEMP_FAILURE_RETRY(close(plugin_fd));
-      free(direntries[i]);
       continue;
     }
     
-    plugin *p = getplugin(direntries[i]->d_name);
+    plugin *p = getplugin(dirst->d_name);
     if(p == NULL){
       error(0, errno, "getplugin");
       TEMP_FAILURE_RETRY(close(plugin_fd));
-      free(direntries[i]);
       continue;
     }
     if(p->disabled){
       if(debug){
 	fprintf(stderr, "Ignoring disabled plugin \"%s\"\n",
-		direntries[i]->d_name);
+		dirst->d_name);
       }
       TEMP_FAILURE_RETRY(close(plugin_fd));
-      free(direntries[i]);
       continue;
     }
     {
@@ -989,47 +975,25 @@
     }
     
     int pipefd[2];
-#ifndef O_CLOEXEC
     ret = (int)TEMP_FAILURE_RETRY(pipe(pipefd));
-#else  /* O_CLOEXEC */
-    ret = (int)TEMP_FAILURE_RETRY(pipe2(pipefd, O_CLOEXEC));
-#endif	/* O_CLOEXEC */
     if(ret == -1){
       error(0, errno, "pipe");
       exitstatus = EX_OSERR;
-      free(direntries[i]);
-      goto fallback;
-    }
-    if(pipefd[0] >= FD_SETSIZE){
-      fprintf(stderr, "pipe()[0] (%d) >= FD_SETSIZE (%d)", pipefd[0],
-	      FD_SETSIZE);
-      TEMP_FAILURE_RETRY(close(pipefd[0]));
-      TEMP_FAILURE_RETRY(close(pipefd[1]));
-      exitstatus = EX_OSERR;
-      free(direntries[i]);
-      goto fallback;
-    }
-#ifndef O_CLOEXEC
+      goto fallback;
+    }
     /* Ask OS to automatic close the pipe on exec */
     ret = set_cloexec_flag(pipefd[0]);
     if(ret < 0){
       error(0, errno, "set_cloexec_flag");
-      TEMP_FAILURE_RETRY(close(pipefd[0]));
-      TEMP_FAILURE_RETRY(close(pipefd[1]));
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
     ret = set_cloexec_flag(pipefd[1]);
     if(ret < 0){
       error(0, errno, "set_cloexec_flag");
-      TEMP_FAILURE_RETRY(close(pipefd[0]));
-      TEMP_FAILURE_RETRY(close(pipefd[1]));
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
-#endif	/* not O_CLOEXEC */
     /* Block SIGCHLD until process is safely in process list */
     ret = (int)TEMP_FAILURE_RETRY(sigprocmask(SIG_BLOCK,
 					      &sigchld_action.sa_mask,
@@ -1037,7 +1001,6 @@
     if(ret < 0){
       error(0, errno, "sigprocmask");
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
     /* Starting a new process to be watched */
@@ -1047,12 +1010,7 @@
     } while(pid == -1 and errno == EINTR);
     if(pid == -1){
       error(0, errno, "fork");
-      TEMP_FAILURE_RETRY(sigprocmask(SIG_UNBLOCK,
-				     &sigchld_action.sa_mask, NULL));
-      TEMP_FAILURE_RETRY(close(pipefd[0]));
-      TEMP_FAILURE_RETRY(close(pipefd[1]));
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
     if(pid == 0){
@@ -1074,11 +1032,15 @@
 	_exit(EX_OSERR);
       }
       
+      if(dirfd(dir) < 0){
+	/* If dir has no file descriptor, we could not set FD_CLOEXEC
+	   above and must now close it manually here. */
+	closedir(dir);
+      }
       if(fexecve(plugin_fd, p->argv,
 		(p->environ[0] != NULL) ? p->environ : environ) < 0){
 	error(0, errno, "fexecve for %s/%s",
-	      plugindir != NULL ? plugindir : PDIR,
-	      direntries[i]->d_name);
+	      plugindir != NULL ? plugindir : PDIR, dirst->d_name);
 	_exit(EX_OSERR);
       }
       /* no return */
@@ -1087,7 +1049,7 @@
     TEMP_FAILURE_RETRY(close(pipefd[1])); /* Close unused write end of
 					     pipe */
     TEMP_FAILURE_RETRY(close(plugin_fd));
-    plugin *new_plugin = getplugin(direntries[i]->d_name);
+    plugin *new_plugin = getplugin(dirst->d_name);
     if(new_plugin == NULL){
       error(0, errno, "getplugin");
       ret = (int)(TEMP_FAILURE_RETRY
@@ -1097,10 +1059,8 @@
         error(0, errno, "sigprocmask");
       }
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
-    free(direntries[i]);
     
     new_plugin->pid = pid;
     new_plugin->fd = pipefd[0];
@@ -1136,10 +1096,8 @@
     }
   }
   
-  free(direntries);
-  direntries = NULL;
-  TEMP_FAILURE_RETRY(close(dir_fd));
-  dir_fd = -1;
+  TEMP_FAILURE_RETRY(closedir(dir));
+  dir = NULL;
   free_plugin(getplugin(NULL));
   
   for(plugin *p = plugin_list; p != NULL; p = p->next){
@@ -1339,10 +1297,8 @@
     free(custom_argv);
   }
   
-  free(direntries);
-  
-  if(dir_fd != -1){
-    TEMP_FAILURE_RETRY(close(dir_fd));
+  if(dir != NULL){
+    closedir(dir);
   }
   
   /* Kill the processes */
@@ -1368,7 +1324,6 @@
   free_plugin_list();
   
   free(plugindir);
-  free(pluginhelperdir);
   free(argfile);
   
   return exitstatus;

=== modified file 'plugin-runner.xml'
--- plugin-runner.xml	2015-06-28 16:35:27 +0000
+++ plugin-runner.xml	2011-12-31 23:05:34 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plugin-runner">
-<!ENTITY TIMESTAMP "2015-06-28">
+<!ENTITY TIMESTAMP "2012-01-01">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -114,9 +114,6 @@
       <arg><option>--plugin-dir=<replaceable
       >DIRECTORY</replaceable></option></arg>
       <sbr/>
-      <arg><option>--plugin-helper-dir=<replaceable
-      >DIRECTORY</replaceable></option></arg>
-      <sbr/>
       <arg><option>--config-file=<replaceable
       >FILE</replaceable></option></arg>
       <sbr/>
@@ -323,21 +320,6 @@
       </varlistentry>
       
       <varlistentry>
-	<term><option>--plugin-helper-dir
-	<replaceable>DIRECTORY</replaceable></option></term>
-	<listitem>
-	  <para>
-	    Specify a different plugin helper directory.  The default
-	    is <filename>/lib/mandos/plugin-helpers</filename>, which
-	    will exist in the initial <acronym>RAM</acronym> disk
-	    environment.  (This will simply be passed to all plugins
-	    via the <envar>MANDOSPLUGINHELPERDIR</envar> environment
-	    variable.  See <xref linkend="writing_plugins"/>)
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
 	<term><option>--config-file
 	<replaceable>FILE</replaceable></option></term>
 	<listitem>
@@ -444,11 +426,7 @@
       <para>
 	The plugin will run in the initial RAM disk environment, so
 	care must be taken not to depend on any files or running
-	services not available there.  Any helper executables required
-	by the plugin (which are not in the <envar>PATH</envar>) can
-	be placed in the plugin helper directory, the name of which
-	will be made available to the plugin via the
-	<envar>MANDOSPLUGINHELPERDIR</envar> environment variable.
+	services not available there.
       </para>
       <para>
 	The plugin must exit cleanly and free all allocated resources
@@ -497,9 +475,7 @@
       only passes on its environment to all the plugins.  The
       environment passed to plugins can be modified using the
       <option>--global-env</option> and <option>--env-for</option>
-      options.  Also, the <option>--plugin-helper-dir</option> option
-      will affect the environment variable
-      <envar>MANDOSPLUGINHELPERDIR</envar> for the plugins.
+      options.
     </para>
   </refsect1>
   

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2014-08-09 23:37:07 +0000
+++ plugins.d/askpass-fifo.c	2014-03-10 07:04:09 +0000
@@ -2,8 +2,8 @@
 /*
  * Askpass-FIFO - Read a password from a FIFO and output it
  * 
- * Copyright © 2008-2014 Teddy Hogeborn
- * Copyright © 2008-2014 Björn Påhlsson
+ * Copyright © 2008-2012 Teddy Hogeborn
+ * Copyright © 2008-2012 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -23,7 +23,7 @@
  */
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY() */
-#include <sys/types.h>		/* uid_t, gid_t, ssize_t */
+#include <sys/types.h>		/* ssize_t */
 #include <sys/stat.h>		/* mkfifo(), S_IRUSR, S_IWUSR */
 #include <iso646.h>		/* and */
 #include <errno.h>		/* errno, EACCES, ENOTDIR, ELOOP,
@@ -44,8 +44,6 @@
 #include <string.h> 		/* strerror() */
 #include <stdarg.h>		/* va_list, va_start(), ... */
 
-uid_t uid = 65534;
-gid_t gid = 65534;
 
 /* Function to use when printing errors */
 __attribute__((format (gnu_printf, 3, 4)))
@@ -76,9 +74,6 @@
   int ret = 0;
   ssize_t sret;
   
-  uid = getuid();
-  gid = getgid();
-  
   /* Create FIFO */
   const char passfifo[] = "/lib/cryptsetup/passfifo";
   ret = mkfifo(passfifo, S_IRUSR | S_IWUSR);
@@ -124,16 +119,6 @@
     }
   }
   
-  /* Lower group privileges  */
-  if(setgid(gid) == -1){
-    error_plus(0, errno, "setgid");
-  }
-  
-  /* Lower user privileges */
-  if(setuid(uid) == -1){
-    error_plus(0, errno, "setuid");
-  }
-  
   /* Read from FIFO */
   char *buf = NULL;
   size_t buf_len = 0;

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2014-08-20 21:46:38 +0000
+++ plugins.d/mandos-client.c	2014-03-23 19:55:18 +0000
@@ -9,8 +9,8 @@
  * "browse_callback", and parts of "main".
  * 
  * Everything else is
- * Copyright © 2008-2014 Teddy Hogeborn
- * Copyright © 2008-2014 Björn Påhlsson
+ * Copyright © 2008-2013 Teddy Hogeborn
+ * Copyright © 2008-2013 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -32,15 +32,15 @@
 /* Needed by GPGME, specifically gpgme_data_seek() */
 #ifndef _LARGEFILE_SOURCE
 #define _LARGEFILE_SOURCE
-#endif	/* not _LARGEFILE_SOURCE */
+#endif
 #ifndef _FILE_OFFSET_BITS
 #define _FILE_OFFSET_BITS 64
-#endif	/* not _FILE_OFFSET_BITS */
+#endif
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY(), asprintf() */
 
 #include <stdio.h>		/* fprintf(), stderr, fwrite(),
-				   stdout, ferror() */
+				   stdout, ferror(), remove() */
 #include <stdint.h> 		/* uint16_t, uint32_t, intptr_t */
 #include <stddef.h>		/* NULL, size_t, ssize_t */
 #include <stdlib.h> 		/* free(), EXIT_SUCCESS, srand(),
@@ -57,7 +57,7 @@
 #include <sys/socket.h>		/* socket(), struct sockaddr_in6,
 				   inet_pton(), connect(),
 				   getnameinfo() */
-#include <fcntl.h>		/* open(), unlinkat() */
+#include <fcntl.h>		/* open() */
 #include <dirent.h>		/* opendir(), struct dirent, readdir()
 				 */
 #include <inttypes.h>		/* PRIu16, PRIdMAX, intmax_t,
@@ -73,8 +73,7 @@
 				*/
 #include <unistd.h>		/* close(), SEEK_SET, off_t, write(),
 				   getuid(), getgid(), seteuid(),
-				   setgid(), pause(), _exit(),
-				   unlinkat() */
+				   setgid(), pause(), _exit() */
 #include <arpa/inet.h>		/* inet_pton(), htons() */
 #include <iso646.h>		/* not, or, and */
 #include <argp.h>		/* struct argp_option, error_t, struct
@@ -137,12 +136,11 @@
 
 bool debug = false;
 static const char mandos_protocol_version[] = "1";
-const char *argp_program_version = "mandos-client " VERSION;
-const char *argp_program_bug_address = "<mandos@recompile.se>";
+const char * argp_program_version = "mandos-client " VERSION;
+const char * argp_program_bug_address = "<mandos@recompile.se>";
 static const char sys_class_net[] = "/sys/class/net";
 char *connect_to = NULL;
 const char *hookdir = HOOKDIR;
-int hookdir_fd = -1;
 uid_t uid = 65534;
 gid_t gid = 65534;
 
@@ -234,21 +232,11 @@
 			  .af = af };
   if(new_server->ip == NULL){
     perror_plus("strdup");
-    free(new_server);
     return false;
   }
   ret = clock_gettime(CLOCK_MONOTONIC, &(new_server->last_seen));
   if(ret == -1){
     perror_plus("clock_gettime");
-#ifdef __GNUC__
-#pragma GCC diagnostic push
-#pragma GCC diagnostic ignored "-Wcast-qual"
-#endif
-    free((char *)(new_server->ip));
-#ifdef __GNUC__
-#pragma GCC diagnostic pop
-#endif
-    free(new_server);
     return false;
   }
   /* Special case of first server */
@@ -1076,7 +1064,6 @@
      timed out */
   
   if(quit_now){
-    avahi_s_service_resolver_free(r);
     return;
   }
   
@@ -1348,7 +1335,7 @@
   sret = strspn(direntry->d_name, "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
 		"abcdefghijklmnopqrstuvwxyz"
 		"0123456789"
-		"_.-");
+		"_-");
   if((direntry->d_name)[sret] != '\0'){
     /* Contains non-allowed characters */
     if(debug){
@@ -1358,7 +1345,14 @@
     return 0;
   }
   
-  ret = fstatat(hookdir_fd, direntry->d_name, &st, 0);
+  char *fullname = NULL;
+  ret = asprintf(&fullname, "%s/%s", hookdir, direntry->d_name);
+  if(ret < 0){
+    perror_plus("asprintf");
+    return 0;
+  }
+  
+  ret = stat(fullname, &st);
   if(ret == -1){
     if(debug){
       perror_plus("Could not stat hook");
@@ -1469,6 +1463,7 @@
   error_t ret_errno = 0;
   if(seteuid(0) == -1){
     ret_errno = errno;
+    perror_plus("seteuid");
   }
   errno = old_errno;
   return ret_errno;
@@ -1485,6 +1480,7 @@
   }
   if(setuid(0) == -1){
     ret_errno = errno;
+    perror_plus("seteuid");
   }
   errno = old_errno;
   return ret_errno;
@@ -1497,6 +1493,7 @@
   error_t ret_errno = 0;
   if(seteuid(uid) == -1){
     ret_errno = errno;
+    perror_plus("seteuid");
   }
   errno = old_errno;
   return ret_errno;
@@ -1509,6 +1506,7 @@
   error_t ret_errno = 0;
   if(setuid(uid) == -1){
     ret_errno = errno;
+    perror_plus("setuid");
   }
   errno = old_errno;
   return ret_errno;
@@ -1517,184 +1515,151 @@
 __attribute__((nonnull))
 void run_network_hooks(const char *mode, const char *interface,
 		       const float delay){
-  struct dirent **direntries = NULL;
-  if(hookdir_fd == -1){
-    hookdir_fd = open(hookdir, O_RDONLY);
-    if(hookdir_fd == -1){
-      if(errno == ENOENT){
-	if(debug){
-	  fprintf_plus(stderr, "Network hook directory \"%s\" not"
-		       " found\n", hookdir);
-	}
-      } else {
-	perror_plus("open");
-      }
-      return;
-    }
-  }
-#ifdef __GLIBC__
-#if __GLIBC_PREREQ(2, 15)
-  int numhooks = scandirat(hookdir_fd, ".", &direntries,
-			   runnable_hook, alphasort);
-#else  /* not __GLIBC_PREREQ(2, 15) */
-  int numhooks = scandir(hookdir, &direntries, runnable_hook,
-			 alphasort);
-#endif	/* not __GLIBC_PREREQ(2, 15) */
-#else	/* not __GLIBC__ */
-  int numhooks = scandir(hookdir, &direntries, runnable_hook,
-			 alphasort);
-#endif	/* not __GLIBC__ */
+  struct dirent **direntries;
+  int numhooks = scandir(hookdir, &direntries, runnable_hook,
+			 alphasort);
   if(numhooks == -1){
-    perror_plus("scandir");
-    return;
-  }
-  struct dirent *direntry;
-  int ret;
-  int devnull = open("/dev/null", O_RDONLY);
-  for(int i = 0; i < numhooks; i++){
-    direntry = direntries[i];
-    if(debug){
-      fprintf_plus(stderr, "Running network hook \"%s\"\n",
-		   direntry->d_name);
+    if(errno == ENOENT){
+      if(debug){
+	fprintf_plus(stderr, "Network hook directory \"%s\" not"
+		     " found\n", hookdir);
+      }
+    } else {
+      perror_plus("scandir");
     }
-    pid_t hook_pid = fork();
-    if(hook_pid == 0){
-      /* Child */
-      /* Raise privileges */
-      errno = raise_privileges_permanently();
-      if(errno != 0){
-	perror_plus("Failed to raise privileges");
-	_exit(EX_NOPERM);
-      }
-      /* Set group */
-      errno = 0;
-      ret = setgid(0);
-      if(ret == -1){
-	perror_plus("setgid");
-	_exit(EX_NOPERM);
-      }
-      /* Reset supplementary groups */
-      errno = 0;
-      ret = setgroups(0, NULL);
-      if(ret == -1){
-	perror_plus("setgroups");
-	_exit(EX_NOPERM);
-      }
-      ret = dup2(devnull, STDIN_FILENO);
-      if(ret == -1){
-	perror_plus("dup2(devnull, STDIN_FILENO)");
-	_exit(EX_OSERR);
-      }
-      ret = close(devnull);
-      if(ret == -1){
-	perror_plus("close");
-	_exit(EX_OSERR);
-      }
-      ret = dup2(STDERR_FILENO, STDOUT_FILENO);
-      if(ret == -1){
-	perror_plus("dup2(STDERR_FILENO, STDOUT_FILENO)");
-	_exit(EX_OSERR);
-      }
-      ret = setenv("MANDOSNETHOOKDIR", hookdir, 1);
-      if(ret == -1){
-	perror_plus("setenv");
-	_exit(EX_OSERR);
-      }
-      ret = setenv("DEVICE", interface, 1);
-      if(ret == -1){
-	perror_plus("setenv");
-	_exit(EX_OSERR);
-      }
-      ret = setenv("VERBOSITY", debug ? "1" : "0", 1);
-      if(ret == -1){
-	perror_plus("setenv");
-	_exit(EX_OSERR);
-      }
-      ret = setenv("MODE", mode, 1);
-      if(ret == -1){
-	perror_plus("setenv");
-	_exit(EX_OSERR);
-      }
-      char *delaystring;
-      ret = asprintf(&delaystring, "%f", (double)delay);
-      if(ret == -1){
+  } else {
+    struct dirent *direntry;
+    int ret;
+    int devnull = open("/dev/null", O_RDONLY);
+    for(int i = 0; i < numhooks; i++){
+      direntry = direntries[i];
+      char *fullname = NULL;
+      ret = asprintf(&fullname, "%s/%s", hookdir, direntry->d_name);
+      if(ret < 0){
 	perror_plus("asprintf");
-	_exit(EX_OSERR);
-      }
-      ret = setenv("DELAY", delaystring, 1);
-      if(ret == -1){
+	continue;
+      }
+      if(debug){
+	fprintf_plus(stderr, "Running network hook \"%s\"\n",
+		     direntry->d_name);
+      }
+      pid_t hook_pid = fork();
+      if(hook_pid == 0){
+	/* Child */
+	/* Raise privileges */
+	if(raise_privileges_permanently() != 0){
+	  perror_plus("Failed to raise privileges");
+	  _exit(EX_NOPERM);
+	}
+	/* Set group */
+	errno = 0;
+	ret = setgid(0);
+	if(ret == -1){
+	  perror_plus("setgid");
+	  _exit(EX_NOPERM);
+	}
+	/* Reset supplementary groups */
+	errno = 0;
+	ret = setgroups(0, NULL);
+	if(ret == -1){
+	  perror_plus("setgroups");
+	  _exit(EX_NOPERM);
+	}
+	ret = dup2(devnull, STDIN_FILENO);
+	if(ret == -1){
+	  perror_plus("dup2(devnull, STDIN_FILENO)");
+	  _exit(EX_OSERR);
+	}
+	ret = close(devnull);
+	if(ret == -1){
+	  perror_plus("close");
+	  _exit(EX_OSERR);
+	}
+	ret = dup2(STDERR_FILENO, STDOUT_FILENO);
+	if(ret == -1){
+	  perror_plus("dup2(STDERR_FILENO, STDOUT_FILENO)");
+	  _exit(EX_OSERR);
+	}
+	ret = setenv("MANDOSNETHOOKDIR", hookdir, 1);
+	if(ret == -1){
+	  perror_plus("setenv");
+	  _exit(EX_OSERR);
+	}
+	ret = setenv("DEVICE", interface, 1);
+	if(ret == -1){
+	  perror_plus("setenv");
+	  _exit(EX_OSERR);
+	}
+	ret = setenv("VERBOSITY", debug ? "1" : "0", 1);
+	if(ret == -1){
+	  perror_plus("setenv");
+	  _exit(EX_OSERR);
+	}
+	ret = setenv("MODE", mode, 1);
+	if(ret == -1){
+	  perror_plus("setenv");
+	  _exit(EX_OSERR);
+	}
+	char *delaystring;
+	ret = asprintf(&delaystring, "%f", (double)delay);
+	if(ret == -1){
+	  perror_plus("asprintf");
+	  _exit(EX_OSERR);
+	}
+	ret = setenv("DELAY", delaystring, 1);
+	if(ret == -1){
+	  free(delaystring);
+	  perror_plus("setenv");
+	  _exit(EX_OSERR);
+	}
 	free(delaystring);
-	perror_plus("setenv");
-	_exit(EX_OSERR);
-      }
-      free(delaystring);
-      if(connect_to != NULL){
-	ret = setenv("CONNECT", connect_to, 1);
-	if(ret == -1){
-	  perror_plus("setenv");
-	  _exit(EX_OSERR);
-	}
-      }
-      int hook_fd = openat(hookdir_fd, direntry->d_name, O_RDONLY);
-      if(hook_fd == -1){
-	perror_plus("openat");
-	_exit(EXIT_FAILURE);
-      }
-      if((int)TEMP_FAILURE_RETRY(close(hookdir_fd)) == -1){
-	perror_plus("close");
-	_exit(EXIT_FAILURE);
-      }
-      if(fexecve(hook_fd, (char *const []){ direntry->d_name, NULL },
-		 environ) == -1){
-	perror_plus("fexecve");
-	_exit(EXIT_FAILURE);
-      }
-    } else {
-      if(hook_pid == -1){
-	perror_plus("fork");
-	free(direntry);
-	continue;
-      }
-      int status;
-      if(TEMP_FAILURE_RETRY(waitpid(hook_pid, &status, 0)) == -1){
-	perror_plus("waitpid");
-	free(direntry);
-	continue;
-      }
-      if(WIFEXITED(status)){
-	if(WEXITSTATUS(status) != 0){
-	  fprintf_plus(stderr, "Warning: network hook \"%s\" exited"
-		       " with status %d\n", direntry->d_name,
-		       WEXITSTATUS(status));
-	  free(direntry);
-	  continue;
-	}
-      } else if(WIFSIGNALED(status)){
-	fprintf_plus(stderr, "Warning: network hook \"%s\" died by"
-		     " signal %d\n", direntry->d_name,
-		     WTERMSIG(status));
-	free(direntry);
-	continue;
+	if(connect_to != NULL){
+	  ret = setenv("CONNECT", connect_to, 1);
+	  if(ret == -1){
+	    perror_plus("setenv");
+	    _exit(EX_OSERR);
+	  }
+	}
+	if(execl(fullname, direntry->d_name, mode, NULL) == -1){
+	  perror_plus("execl");
+	  _exit(EXIT_FAILURE);
+	}
       } else {
-	fprintf_plus(stderr, "Warning: network hook \"%s\""
-		     " crashed\n", direntry->d_name);
-	free(direntry);
-	continue;
-      }
-    }
-    if(debug){
-      fprintf_plus(stderr, "Network hook \"%s\" ran successfully\n",
-		   direntry->d_name);
-    }
-    free(direntry);
-  }
-  free(direntries);
-  if((int)TEMP_FAILURE_RETRY(close(hookdir_fd)) == -1){
-    perror_plus("close");
-  } else {
-    hookdir_fd = -1;
-  }
-  close(devnull);
+	int status;
+	if(TEMP_FAILURE_RETRY(waitpid(hook_pid, &status, 0)) == -1){
+	  perror_plus("waitpid");
+	  free(fullname);
+	  continue;
+	}
+	if(WIFEXITED(status)){
+	  if(WEXITSTATUS(status) != 0){
+	    fprintf_plus(stderr, "Warning: network hook \"%s\" exited"
+			 " with status %d\n", direntry->d_name,
+			 WEXITSTATUS(status));
+	    free(fullname);
+	    continue;
+	  }
+	} else if(WIFSIGNALED(status)){
+	  fprintf_plus(stderr, "Warning: network hook \"%s\" died by"
+		       " signal %d\n", direntry->d_name,
+		       WTERMSIG(status));
+	  free(fullname);
+	  continue;
+	} else {
+	  fprintf_plus(stderr, "Warning: network hook \"%s\""
+		       " crashed\n", direntry->d_name);
+	  free(fullname);
+	  continue;
+	}
+      }
+      free(fullname);
+      if(debug){
+	fprintf_plus(stderr, "Network hook \"%s\" ran successfully\n",
+		     direntry->d_name);
+      }
+    }
+    close(devnull);
+  }
 }
 
 __attribute__((nonnull, warn_unused_result))
@@ -1750,14 +1715,12 @@
     
     /* Raise privileges */
     ret_errno = raise_privileges();
+    bool restore_loglevel = false;
     if(ret_errno != 0){
-      errno = ret_errno;
       perror_plus("Failed to raise privileges");
     }
-    
 #ifdef __linux__
     int ret_linux;
-    bool restore_loglevel = false;
     if(ret_errno == 0){
       /* Lower kernel loglevel to KERN_NOTICE to avoid KERN_INFO
 	 messages about the network interface to mess up the prompt */
@@ -1861,10 +1824,8 @@
     /* Raise privileges */
     ret_errno = raise_privileges();
     if(ret_errno != 0){
-      errno = ret_errno;
       perror_plus("Failed to raise privileges");
     }
-    
     int ret_setflags = ioctl(sd, SIOCSIFFLAGS, &network);
     ioctl_errno = errno;
     
@@ -2274,7 +2235,7 @@
   
   /* If no interfaces were specified, make a list */
   if(mc.interfaces == NULL){
-    struct dirent **direntries = NULL;
+    struct dirent **direntries;
     /* Look for any good interfaces */
     ret = scandir(sys_class_net, &direntries, good_interface,
 		  alphasort);
@@ -2286,20 +2247,16 @@
 	if(ret_errno != 0){
 	  errno = ret_errno;
 	  perror_plus("argz_add");
-	  free(direntries[i]);
 	  continue;
 	}
 	if(debug){
 	  fprintf_plus(stderr, "Will use interface \"%s\"\n",
 		       direntries[i]->d_name);
 	}
-	free(direntries[i]);
       }
       free(direntries);
     } else {
-      if(ret == 0){
-	free(direntries);
-      }
+      free(direntries);
       fprintf_plus(stderr, "Could not find a network interface\n");
       exitcode = EXIT_FAILURE;
       goto end;
@@ -2527,7 +2484,7 @@
   if(debug){
     fprintf_plus(stderr, "Starting Avahi loop search\n");
   }
-  
+
   ret = avahi_loop_with_timeout(simple_poll,
 				(int)(retry_interval * 1000), &mc);
   if(debug){
@@ -2569,14 +2526,6 @@
     mc.current_server->prev->next = NULL;
     while(mc.current_server != NULL){
       server *next = mc.current_server->next;
-#ifdef __GNUC__
-#pragma GCC diagnostic push
-#pragma GCC diagnostic ignored "-Wcast-qual"
-#endif
-      free((char *)(mc.current_server->ip));
-#ifdef __GNUC__
-#pragma GCC diagnostic pop
-#endif
       free(mc.current_server);
       mc.current_server = next;
     }
@@ -2586,7 +2535,6 @@
   {
     ret_errno = raise_privileges();
     if(ret_errno != 0){
-      errno = ret_errno;
       perror_plus("Failed to raise privileges");
     } else {
       
@@ -2612,10 +2560,8 @@
 	}
       }
     }
-    
     ret_errno = lower_privileges_permanently();
     if(ret_errno != 0){
-      errno = ret_errno;
       perror_plus("Failed to lower privileges permanently");
     }
   }
@@ -2626,45 +2572,36 @@
   /* Removes the GPGME temp directory and all files inside */
   if(tempdir != NULL){
     struct dirent **direntries = NULL;
-    int tempdir_fd = (int)TEMP_FAILURE_RETRY(open(tempdir, O_RDONLY |
-						  O_NOFOLLOW));
-    if(tempdir_fd == -1){
-      perror_plus("open");
-    } else {
-#ifdef __GLIBC__
-#if __GLIBC_PREREQ(2, 15)
-      int numentries = scandirat(tempdir_fd, ".", &direntries,
-				 notdotentries, alphasort);
-#else  /* not __GLIBC_PREREQ(2, 15) */
-      int numentries = scandir(tempdir, &direntries, notdotentries,
-			       alphasort);
-#endif	/* not __GLIBC_PREREQ(2, 15) */
-#else	/* not __GLIBC__ */
-      int numentries = scandir(tempdir, &direntries, notdotentries,
-			       alphasort);
-#endif	/* not __GLIBC__ */
-      if(numentries >= 0){
-	for(int i = 0; i < numentries; i++){
-	  ret = unlinkat(tempdir_fd, direntries[i]->d_name, 0);
-	  if(ret == -1){
-	    fprintf_plus(stderr, "unlinkat(open(\"%s\", O_RDONLY),"
-			 " \"%s\", 0): %s\n", tempdir,
-			 direntries[i]->d_name, strerror(errno));
-	  }
-	  free(direntries[i]);
-	}
-	
-	/* need to clean even if 0 because man page doesn't specify */
-	free(direntries);
-	if(numentries == -1){
-	  perror_plus("scandir");
-	}
-	ret = rmdir(tempdir);
-	if(ret == -1 and errno != ENOENT){
-	  perror_plus("rmdir");
-	}
+    struct dirent *direntry = NULL;
+    int numentries = scandir(tempdir, &direntries, notdotentries,
+			     alphasort);
+    if(numentries > 0){
+      for(int i = 0; i < numentries; i++){
+	direntry = direntries[i];
+	char *fullname = NULL;
+	ret = asprintf(&fullname, "%s/%s", tempdir,
+		       direntry->d_name);
+	if(ret < 0){
+	  perror_plus("asprintf");
+	  continue;
+	}
+	ret = remove(fullname);
+	if(ret == -1){
+	  fprintf_plus(stderr, "remove(\"%s\"): %s\n", fullname,
+		       strerror(errno));
+	}
+	free(fullname);
       }
-      TEMP_FAILURE_RETRY(close(tempdir_fd));
+    }
+
+    /* need to clean even if 0 because man page doesn't specify */
+    free(direntries);
+    if(numentries == -1){
+      perror_plus("scandir");
+    }
+    ret = rmdir(tempdir);
+    if(ret == -1 and errno != ENOENT){
+      perror_plus("rmdir");
     }
   }
   

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2014-06-22 02:19:30 +0000
+++ plugins.d/mandos-client.xml	2014-03-06 02:26:04 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-client">
-<!ENTITY TIMESTAMP "2014-06-22">
+<!ENTITY TIMESTAMP "2014-03-05">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -748,9 +748,8 @@
     <para>
       It will also help if the checker program on the server is
       configured to request something from the client which can not be
-      spoofed by someone else on the network, like SSH server key
-      fingerprints, and unlike unencrypted <acronym>ICMP</acronym>
-      echo (<quote>ping</quote>) replies.
+      spoofed by someone else on the network, unlike unencrypted
+      <acronym>ICMP</acronym> echo (<quote>ping</quote>) replies.
     </para>
     <para>
       <emphasis>Note</emphasis>: This makes it completely insecure to

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2014-03-29 02:38:15 +0000
+++ plugins.d/password-prompt.c	2014-03-10 07:04:09 +0000
@@ -2,8 +2,8 @@
 /*
  * Password-prompt - Read a password from the terminal and print it
  * 
- * Copyright © 2008-2014 Teddy Hogeborn
- * Copyright © 2008-2014 Björn Påhlsson
+ * Copyright © 2008-2013 Teddy Hogeborn
+ * Copyright © 2008-2013 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

=== modified file 'plugins.d/plymouth.c'
--- plugins.d/plymouth.c	2014-03-29 02:38:15 +0000
+++ plugins.d/plymouth.c	2014-03-10 07:04:09 +0000
@@ -2,8 +2,8 @@
 /*
  * Plymouth - Read a password from Plymouth and output it
  * 
- * Copyright © 2010-2014 Teddy Hogeborn
- * Copyright © 2010-2014 Björn Påhlsson
+ * Copyright © 2010-2013 Teddy Hogeborn
+ * Copyright © 2010-2013 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

=== modified file 'plugins.d/splashy.c'
--- plugins.d/splashy.c	2014-03-29 02:38:15 +0000
+++ plugins.d/splashy.c	2014-03-10 07:04:09 +0000
@@ -2,8 +2,8 @@
 /*
  * Splashy - Read a password from splashy and output it
  * 
- * Copyright © 2008-2014 Teddy Hogeborn
- * Copyright © 2008-2014 Björn Påhlsson
+ * Copyright © 2008-2012 Teddy Hogeborn
+ * Copyright © 2008-2012 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

=== modified file 'plugins.d/usplash.c'
--- plugins.d/usplash.c	2014-03-29 02:38:15 +0000
+++ plugins.d/usplash.c	2014-03-10 07:04:09 +0000
@@ -2,8 +2,8 @@
 /*
  * Usplash - Read a password from usplash and output it
  * 
- * Copyright © 2008-2014 Teddy Hogeborn
- * Copyright © 2008-2014 Björn Påhlsson
+ * Copyright © 2008-2012 Teddy Hogeborn
+ * Copyright © 2008-2012 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

